﻿--[[
	Copyright (c) 2009, dr_AllCOM3
    All rights reserved.

    You're allowed to use this addon, free of monetary charge,
    but you are not allowed to modify, alter, or redistribute
    this addon without express, written permission of the author.
]]

if DocsUI_AuraScanner then return end
DocsUI_AuraScanner = LibStub("AceAddon-3.0"):NewAddon("DocsUI_AuraScanner", "AceEvent-3.0")
local db
local temp, temp2 = nil


DocsUI_AuraScanner.doUpdateAuras = {}
local doUpdateAuras = DocsUI_AuraScanner.doUpdateAuras
DocsUI_AuraScanner.auras = {}
local auras = DocsUI_AuraScanner.auras

--[[ Wipe table ]]
local function emptyNumericTable(table, maxIndex)
    maxIndex = maxIndex or #table
    
    for i=1,maxIndex do
        table[i] = nil
    end
end

--[[ On Aura Update ]]
local name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId
-- [1]name, [2]rank, [3]icon, [4]count, [5]debuffType, [6]duration, [7]expirationTime, [8]unitCaster, [9]isStealable, [10]shouldConsolidate, [11]spellId
local function onAuraUpdate(unit)
    if not unit then return end
    
    if not auras[unit] then
        auras[unit] = { HELPFUL = {}, HARMFUL = {} }
        for j=1,40 do
            auras[unit].HELPFUL[j] = {}
            auras[unit].HARMFUL[j] = {}
        end
    end
    
    if unit=="player" or unit=="target" or unit=="pet" or unit=="vehicle" then -- or unit=="mouseover" or strfind(unit, "raid") or strfind(unit, "party")
        for i=1,40 do
            emptyNumericTable(auras[unit].HELPFUL[i])
            
            name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId = UnitAura(unit, i, "HELPFUL")
                
            if name then
                auras[unit].HELPFUL[i][1] = name
                auras[unit].HELPFUL[i][2] = rank
                auras[unit].HELPFUL[i][3] = icon
                auras[unit].HELPFUL[i][4] = count
                auras[unit].HELPFUL[i][5] = debuffType
                auras[unit].HELPFUL[i][6] = duration
                auras[unit].HELPFUL[i][7] = expirationTime
                auras[unit].HELPFUL[i][8] = unitCaster
                auras[unit].HELPFUL[i][9] = isStealable
                auras[unit].HELPFUL[i][10] = shouldConsolidate
                auras[unit].HELPFUL[i][11] = spellId
                auras[unit].HELPFUL[i][12] = i
                auras[unit].HELPFUL[i][13] = "HELPFUL"
                auras[unit].HELPFUL[i][14] = unit
                
                --[[DocsUI:p( " "..#auras[unit].HELPFUL[i].."_"..i.." "..tostring(name)..";"..tostring(rank)..";"..strsub(tostring(icon),1,3)..";"..tostring(count)..";"
                ..tostring(debuffType)..";"..tostring(duration)..";"..tostring(expirationTime)..";"..tostring(unitCaster)..";"
                ..tostring(isStealable)..";"..tostring(shouldConsolidate)..";"..tostring(spellId)..";"..i..";".."HELPFUL"..";"..tostring(unit))]]
                
            else
                --break
            end
        end
        
        for i=1,40 do
            emptyNumericTable(auras[unit].HARMFUL[i])
            
            name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId = UnitAura(unit, i, "HARMFUL")
            
            if name then
                auras[unit].HARMFUL[i][1] = name
                auras[unit].HARMFUL[i][2] = rank
                auras[unit].HARMFUL[i][3] = icon
                auras[unit].HARMFUL[i][4] = count
                auras[unit].HARMFUL[i][5] = debuffType
                auras[unit].HARMFUL[i][6] = duration
                auras[unit].HARMFUL[i][7] = expirationTime
                auras[unit].HARMFUL[i][8] = unitCaster
                auras[unit].HARMFUL[i][9] = isStealable
                auras[unit].HARMFUL[i][10] = shouldConsolidate
                auras[unit].HARMFUL[i][11] = spellId
                auras[unit].HARMFUL[i][12] = i
                auras[unit].HARMFUL[i][13] = "HARMFUL"
                auras[unit].HARMFUL[i][14] = unit
                
                --[[if unit=="player" then
                DocsUI:p( " _"..i.." "..tostring(name)..";"..tostring(rank)..";"..strsub(tostring(icon),1,3)..";"..tostring(count)..";"
                ..tostring(debuffType)..";"..tostring(duration)..";"..tostring(expirationTime)..";"..tostring(unitCaster)..";"
                ..tostring(isStealable)..";"..tostring(shouldConsolidate)..";"..tostring(spellId)..";"..i..";".."HARMFUL"..";"..tostring(unit)..";   ")
                end]]
            else
                --break
            end
        end
        
        for i=1,#doUpdateAuras do
            if type( doUpdateAuras[i] )=="function" then doUpdateAuras[i]( unit, unit ) end
        end
    end
end

-- Update Auras
function DocsUI_AuraScanner:UpdateAuras(self, unit, x)
    onAuraUpdate(unit)
end

-- PLAYER_ENTERING_WORLD
function DocsUI_AuraScanner:PLAYER_ENTERING_WORLD(self)
    onAuraUpdate("player")
    onAuraUpdate("pet")
end
-- PLAYER_TARGET_CHANGED
function DocsUI_AuraScanner:PLAYER_TARGET_CHANGED(self)
    onAuraUpdate("target")
end
-- UNIT_AURA
function DocsUI_AuraScanner:UNIT_AURA(self, unit)
    onAuraUpdate(unit)
end

-- OnInitialize
function DocsUI_AuraScanner:OnInitialize()
    
end
-- OnEnable
function DocsUI_AuraScanner:OnEnable()
    
    self:RegisterEvent("PLAYER_ENTERING_WORLD")
    self:RegisterEvent("PLAYER_TARGET_CHANGED")
    self:RegisterEvent("UNIT_AURA")
    
end
function DocsUI_AuraScanner:OnDisable()
	
end

--test
function DocsUI_AuraScanner:scanTest()
    local unit="player"
    for i=1,40 do
        emptyNumericTable(auras[unit].HARMFUL[i])
        
        temp = random(1,9)..i..random(1,9)..random(1,9)..random(1,9)
        local name, rank, icon, cost, isFunnel, powerType, castTime, minRange, maxRange = GetSpellInfo(temp)
        castTime = castTime or 1.5
        --name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId = UnitAura(unit, i, "HARMFUL")
        
        -- [1]name,[2]rank,[3]icon,[4]count,[5]debuffType,[6]duration,[7]expirationTime,[8]unitCaster,[9]isStealable,[10]shouldConsolidate,[11]spellId,[12]index,[13]filter,[14]unit
        auras[unit].HARMFUL[i][1] = name
        auras[unit].HARMFUL[i][2] = rank
        auras[unit].HARMFUL[i][3] = icon
        auras[unit].HARMFUL[i][4] = i
        auras[unit].HARMFUL[i][5] = nil
        auras[unit].HARMFUL[i][6] = castTime
        auras[unit].HARMFUL[i][7] = GetTime()+castTime
        auras[unit].HARMFUL[i][8] = "target"
        auras[unit].HARMFUL[i][9] = nil
        auras[unit].HARMFUL[i][10] = nil
        auras[unit].HARMFUL[i][11] = temp
        auras[unit].HARMFUL[i][12] = i
        auras[unit].HARMFUL[i][13] = "HARMFUL"
        auras[unit].HARMFUL[i][14] = "player"
    end
    
    doUpdateAuras(unit, unit)
    
    --DocsUI:p( tostring(name) )
    return 
end