﻿--[[
	Copyright (c) 2009, dr_AllCOM3
    All rights reserved.

    You're allowed to use this addon, free of monetary charge,
    but you are not allowed to modify, alter, or redistribute
    this addon without express, written permission of the author.
]]

local L = LibStub("AceLocale-3.0"):GetLocale("DocsUI")
local LSM = LibStub("LibSharedMedia-3.0")
local db
local temp,temp2 = nil

--[[ Print ]]
local function p( text )
	ChatFrame3:AddMessage( tostring( text ) )
end

local UnitAura = UnitAura
local strlower = strlower
local GetTime = GetTime
local sort = sort
local unpack = unpack
local tonumber = tonumber
local tostring = tostring
local ipairs = ipairs
local next = next
local pairs	= pairs

local frames = {}
local tempFrameList = {}
local updateFramesList = {}
local auras, r, g, b

local frostFeverLocal = GetSpellInfo(59921)
local bloodPlagueLocal = GetSpellInfo(59879)
local chilledBoneLocal = GetSpellInfo(70106)
local instabilityLocal = GetSpellInfo(69766)

--[[ Round a number ]]
-- number, decimal places
local function round(num, idp)
	local mult = 10^(idp or 0)
	return math.floor(num * mult + 0.5) / mult
end

--[[ Format time ]]
local function formatTime(time)
    if time>60 then
        time = floor(time/60).."m"
    else
        time = time
    end
    
    return time
end

--[[ Wipe table ]]
local function emptyNumericTable(table, maxIndex)
    maxIndex = maxIndex or #table
    
    for i=1,maxIndex do
        table[i] = nil
    end
end

--[[ Reset table ]]
local function resetBuffTable(table)
    -- [1]name, [2]rank, [3]icon, [4]count, [5]debuffType, [6]duration, [7]expirationTime, [8]unitCaster, [9]isStealable, [10]shouldConsolidate, [11]spellId, [12]index,[13]filter,[14]unit
    table[1] = "none"
    --table[2] = nil
    table[3] = nil
    --table[4] = nil
    --table[5] = nil
    --table[6] = 0
    table[7] = -99999*60
    --table[8] = nil
    --table[9] = nil
    --table[10] = nil
    --table[11] = nil
    --table[12] = nil
    --table[13] = nil
    --table[14] = nil
end

--[[ Sort by time ]]
local function sortByTime(a,b)
    --[1]name, [7]expirationTime
    if a[7]-temp==b[7]-temp then
        return a[1]>b[1]
    else
        return a[7]-temp>b[7]-temp
    end
end
 
--[[ Buff frame Update ]]
local function buffFrameUpdate(value)
    -- [1]name,[2]rank,[3]icon,[4]count,[5]debuffType,[6]duration,[7]expirationTime,[8]unitCaster,[9]isStealable,[10]shouldConsolidate,[11]spellId,[12]index,[13]filter,[14]unit
    temp = GetTime()
    sort(value.list, sortByTime)
    
    for i=1,40 do
        if not value[i] then
            break
        elseif value.list[i] and value.list[i][3] and value.list[i][12] then
            if not value[i]:IsVisible() and not value[i].index then value[i]:Show() end
            if value[i].unit~=value.list[i][14] then value[i].unit = value.list[i][14] end
            if value[i].name~=value.list[i][1] then value[i].name = value.list[i][1] end
            if value[i].filter~=value.list[i][13] then value[i].filter = value.list[i][13] end
            if value[i].index~=value.list[i][12] then value[i].index = value.list[i][12] end
            if value[i].expirationTime~=value.list[i][7] then value[i].expirationTime = value.list[i][7] end
            if value[i].duration~=value.list[i][6] then value[i].duration = value.list[i][6] end
            if value[i].count~=value.list[i][4] then value[i].count = value.list[i][4] end
            
            if value[i].bar then value[i].bar:SetValue(1) end
            if value[i].icon:GetTexture()~=value.list[i][3] then value[i].icon:SetTexture(value.list[i][3]) end
            if value[i].text and value[i].text:GetText()~=value.list[i][1] then value[i].text:SetText(value.list[i][1]) end
            
            temp = value.list[i][7]
            if temp and temp>0 and value.list[i][6]>0 then
                temp2 = temp-GetTime()
                
                if temp2>10000 or temp2<0 then
                    if value[i].time:GetText()~=nil then value[i].time:SetText(nil) end
                else
                    value[i].time:SetText(formatTime(round(temp2,0)))
                end
            else
                if value[i].time:GetText()~=nil then value[i].time:SetText(nil) end
            end
            
            temp = value.list[i][4]
            if value[i].counter and temp and temp>0 then
                value[i].counter:SetText(value.list[i][4])
            elseif value[i].counter then
                if value[i].counter:GetText()~=nil then value[i].counter:SetText(nil) end 
            end
            
            if value.list[i][14]=="target" and value.list[i][8]=="player" and value.list[i][1]==frostFeverLocal then -- Frost Fever
                if value[i].bar then value[i].bar:SetStatusBarColor(0,0.45,0.6,db.fgColor.a) end
                temp = 1.5
                value[i].time:SetTextColor(0+(1-0)/temp, 0.45+(1-0.45)/temp, 0.6+(1-0.6)/temp, db.fontColor.a)
            elseif value.list[i][14]=="target" and value.list[i][8]=="player" and value.list[i][1]==bloodPlagueLocal then -- Blood Plague
                if value[i].bar then value[i].bar:SetStatusBarColor(0.5,0,0.6,db.fgColor.a) end
                temp = 1.5
                value[i].time:SetTextColor(0.5+(1-0.5)/temp, 0+(1-0)/temp, 0.6+(1-0.6)/temp, db.fontColor.a)
            elseif value.list[i][14]=="target" and value.list[i][8]=="player" and value.list[i][13]=="HARMFUL" then
                if value[i].bar then value[i].bar:SetStatusBarColor(db.fgColor.r, db.fgColor.g, db.fgColor.b, db.fgColor.a) end
                value[i].time:SetTextColor(db.fontColor.r,db.fontColor.g,db.fontColor.b,db.fontColor.a)
            elseif value.list[i][14]=="player" and value.list[i][13]=="HARMFUL" then
                if value.list[i][1]==chilledBoneLocal or value.list[i][1]==instabilityLocal then --Chilled to the Bone, Instability
                    if value[i].bar then value[i].bar:SetStatusBarColor(0.33, 0.33, 1, 0.75) end
                else
                    if value[i].bar then value[i].bar:SetStatusBarColor(1, 0, 0, 0.75) end
                end
            end
        else
            if value[i]:IsVisible() and value[i].index then value[i]:Hide() end
            value[i].index = nil
        end
    end
    
end

--[[ On Aura Update ]]
local name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId, index, filter, u
-- [1]name, [2]rank, [3]icon, [4]count, [5]debuffType, [6]duration, [7]expirationTime, [8]unitCaster, [9]isStealable, [10]shouldConsolidate, [11]spellId, [12]index,[13]filter,[14]unit
local function scan(unit)
    if unit and (unit=="player" or unit=="vehicle") then --[[PLAYER]]
        for i=1,30 do
            resetBuffTable(frames["buffs"].list[i])
            resetBuffTable(frames["buffFilterPlayerRaidBuffs"].list[i])
        end
        for i=1,8 do
            resetBuffTable(frames["buffFilterPlayerShort"].list[i])
            resetBuffTable(frames["buffFilterPlayerLong"].list[i])
            resetBuffTable(frames["debuffs"].list[i])
        end
        
        for i=1,40 do
            if not auras[unit].HELPFUL[i][1] then
                break
            end
            temp = false
            
            name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId, index, filter, u = unpack( auras[unit].HELPFUL[i],1,14 )
            
            for j=1,#db.buffFilterPlayerShort do
                if db.buffFilterPlayerShort[j]==strlower(name) then
                    if expirationTime==0 then expirationTime = 66666*60 end -- so there isn't a huge negative number shown
                    
                    tempFrameList = frames["buffFilterPlayerShort"]
                    for k=1,#tempFrameList.list do
                        if not tempFrameList.list[k][3] then
                            temp2 = k
                            break
                        end
                    end
                    
                    tempFrameList.list[temp2][1] = name
                    tempFrameList.list[temp2][2] = rank
                    tempFrameList.list[temp2][3] = icon
                    tempFrameList.list[temp2][4] = count
                    tempFrameList.list[temp2][5] = debuffType
                    tempFrameList.list[temp2][6] = duration
                    tempFrameList.list[temp2][7] = expirationTime
                    tempFrameList.list[temp2][8] = unitCaster
                    tempFrameList.list[temp2][9] = isStealable
                    tempFrameList.list[temp2][10] = shouldConsolidate
                    tempFrameList.list[temp2][11] = spellId
                    tempFrameList.list[temp2][12] = index
                    tempFrameList.list[temp2][13] = filter
                    tempFrameList.list[temp2][14] = u
                    
                    temp = true
                    break
                end
            end
            
            if not temp then
                for j=1,#db.buffFilterPlayerLong do
                    if db.buffFilterPlayerLong[j]==strlower(name) then
                        if expirationTime==0 then expirationTime = 66666*60 end -- so there isn't a huge negative number shown
                        
                        tempFrameList = frames["buffFilterPlayerLong"]
                        for k=1,#tempFrameList.list do
                            if not tempFrameList.list[k][3] then
                                temp2 = k
                                break
                            end
                        end
                        
                        tempFrameList.list[temp2][1] = name
                        tempFrameList.list[temp2][2] = rank
                        tempFrameList.list[temp2][3] = icon
                        tempFrameList.list[temp2][4] = count
                        tempFrameList.list[temp2][5] = debuffType
                        tempFrameList.list[temp2][6] = duration
                        tempFrameList.list[temp2][7] = expirationTime
                        tempFrameList.list[temp2][8] = unitCaster
                        tempFrameList.list[temp2][9] = isStealable
                        tempFrameList.list[temp2][10] = shouldConsolidate
                        tempFrameList.list[temp2][11] = spellId
                        tempFrameList.list[temp2][12] = index
                        tempFrameList.list[temp2][13] = filter
                        tempFrameList.list[temp2][14] = u
                        
                        temp = true
                        break
                    end
                end
            end
            
            if not temp then
                for j=1,#db.buffFilterPlayerRaidBuffs do
                    if db.buffFilterPlayerRaidBuffs[j]==strlower(name) then
                        if expirationTime==0 then expirationTime = 66666*60 end -- so there isn't a huge negative number shown
                        
                        tempFrameList = frames["buffFilterPlayerRaidBuffs"]
                        for k=1,#tempFrameList.list do
                            if not tempFrameList.list[k][3] then
                                temp2 = k
                                break
                            end
                        end
                        
                        tempFrameList.list[temp2][1] = name
                        tempFrameList.list[temp2][2] = rank
                        tempFrameList.list[temp2][3] = icon
                        tempFrameList.list[temp2][4] = count
                        tempFrameList.list[temp2][5] = debuffType
                        tempFrameList.list[temp2][6] = duration
                        tempFrameList.list[temp2][7] = expirationTime
                        tempFrameList.list[temp2][8] = unitCaster
                        tempFrameList.list[temp2][9] = isStealable
                        tempFrameList.list[temp2][10] = shouldConsolidate
                        tempFrameList.list[temp2][11] = spellId
                        tempFrameList.list[temp2][12] = index
                        tempFrameList.list[temp2][13] = filter
                        tempFrameList.list[temp2][14] = u
                        
                        temp = true
                        break
                    end
                end
            end
            
            if not temp then
                if expirationTime==0 then expirationTime = 66666*60 end -- so there isn't a huge negative number shown
                
                tempFrameList = frames["buffs"]
                for k=1,#tempFrameList.list do
                    if not tempFrameList.list[k][3] then
                        temp2 = k
                        break
                    end
                end
                
                tempFrameList.list[temp2][1] = name
                tempFrameList.list[temp2][2] = rank
                tempFrameList.list[temp2][3] = icon
                tempFrameList.list[temp2][4] = count
                tempFrameList.list[temp2][5] = debuffType
                tempFrameList.list[temp2][6] = duration
                tempFrameList.list[temp2][7] = expirationTime
                tempFrameList.list[temp2][8] = unitCaster
                tempFrameList.list[temp2][9] = isStealable
                tempFrameList.list[temp2][10] = shouldConsolidate
                tempFrameList.list[temp2][11] = spellId
                tempFrameList.list[temp2][12] = index
                tempFrameList.list[temp2][13] = filter
                tempFrameList.list[temp2][14] = u
                
            end
        end
        
        for i=1,40 do
            if not auras[unit].HARMFUL[i][1] then
                break
            end
            
            name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId, index, filter, u = unpack( auras[unit].HARMFUL[i],1,14 )
            
            temp = false
            
            for j=1,#db.buffFilterPlayerDebuffs do
                if db.buffFilterPlayerDebuffs[j]==strlower(name) then
                    --
                    
                    temp = true
                    break
                end
            end
            
            if not temp then
                if expirationTime==0 then expirationTime = 66666*60 end -- so there isn't a huge negative number shown
                
                tempFrameList = frames["debuffs"]
                for k=1,#tempFrameList.list do
                    if not tempFrameList.list[k][3] then
                        temp2 = k
                        break
                    end
                end
                
                tempFrameList.list[temp2][1] = name
                tempFrameList.list[temp2][2] = rank
                tempFrameList.list[temp2][3] = icon
                tempFrameList.list[temp2][4] = count
                tempFrameList.list[temp2][5] = debuffType
                tempFrameList.list[temp2][6] = duration
                tempFrameList.list[temp2][7] = expirationTime
                tempFrameList.list[temp2][8] = unitCaster
                tempFrameList.list[temp2][9] = isStealable
                tempFrameList.list[temp2][10] = shouldConsolidate
                tempFrameList.list[temp2][11] = spellId
                tempFrameList.list[temp2][12] = index
                tempFrameList.list[temp2][13] = filter
                tempFrameList.list[temp2][14] = u
            end
            
            updateFramesList[tostring( frames["debuffs"] )] = frames["debuffs"]
        end
        
        updateFramesList[tostring( frames["buffs"] )] = frames["buffs"]
        updateFramesList[tostring( frames["buffFilterPlayerShort"] )] = frames["buffFilterPlayerShort"]
        updateFramesList[tostring( frames["buffFilterPlayerLong"] )] = frames["buffFilterPlayerLong"]
        updateFramesList[tostring( frames["buffFilterPlayerRaidBuffs"] )] = frames["buffFilterPlayerRaidBuffs"]
        updateFramesList[tostring( frames["debuffs"] )] = frames["debuffs"]
    elseif unit and unit=="target" then --[[TARGET]]
        for i=1,8 do
            resetBuffTable(frames["buffFilterTargetMyDebuffs"].list[i])
            resetBuffTable(frames["buffFilterTargetMyBuffs"].list[i])
        end
        
        for i=1,40 do
            if not auras[unit].HELPFUL[i][1] then
                break
            end
            temp = false
            
            name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId, index, filter, u = unpack( auras[unit].HELPFUL[i],1,14 )
            
            if unitCaster=="player" then
                for j=1,#db.buffFilterTargetMyBuffs do
                    if db.buffFilterTargetMyBuffs[j]==strlower(name) then
                        if expirationTime==0 then expirationTime = 66666*60 end -- so there isn't a huge negative number shown
                        
                        tempFrameList = frames["buffFilterTargetMyBuffs"]
                        for k=1,#tempFrameList.list do
                            if not tempFrameList.list[k][3] then
                                temp2 = k
                                break
                            end
                        end
                        
                        tempFrameList.list[temp2][1] = name
                        tempFrameList.list[temp2][2] = rank
                        tempFrameList.list[temp2][3] = icon
                        tempFrameList.list[temp2][4] = count
                        tempFrameList.list[temp2][5] = debuffType
                        tempFrameList.list[temp2][6] = duration
                        tempFrameList.list[temp2][7] = expirationTime
                        tempFrameList.list[temp2][8] = unitCaster
                        tempFrameList.list[temp2][9] = isStealable
                        tempFrameList.list[temp2][10] = shouldConsolidate
                        tempFrameList.list[temp2][11] = spellId
                        tempFrameList.list[temp2][12] = index
                        tempFrameList.list[temp2][13] = filter
                        tempFrameList.list[temp2][14] = u
                        
                        temp = true
                        break
                    end
                end
            else
                for j=1,#db.buffFilterTargetOthersBuffs do
                    if db.buffFilterTargetOthersBuffs[j]==strlower(name) then
                        if expirationTime==0 then expirationTime = 66666*60 end -- so there isn't a huge negative number shown
                        
                        tempFrameList = frames["buffFilterTargetMyBuffs"]
                        for k=1,#tempFrameList.list do
                            if not tempFrameList.list[k][3] then
                                temp2 = k
                                break
                            end
                        end
                        
                        tempFrameList.list[temp2][1] = name
                        tempFrameList.list[temp2][2] = rank
                        tempFrameList.list[temp2][3] = icon
                        tempFrameList.list[temp2][4] = count
                        tempFrameList.list[temp2][5] = debuffType
                        tempFrameList.list[temp2][6] = duration
                        tempFrameList.list[temp2][7] = expirationTime
                        tempFrameList.list[temp2][8] = unitCaster
                        tempFrameList.list[temp2][9] = isStealable
                        tempFrameList.list[temp2][10] = shouldConsolidate
                        tempFrameList.list[temp2][11] = spellId
                        tempFrameList.list[temp2][12] = index
                        tempFrameList.list[temp2][13] = filter
                        tempFrameList.list[temp2][14] = u
                        
                        temp = true
                        break
                    end
                end
            end
        end
        
        for i=1,40 do
            if not auras[unit].HARMFUL[i][1] then
                break
            end
            temp = false
            
            name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId, index, filter, u = unpack( auras[unit].HARMFUL[i],1,14 )
            
            temp = false
            
            if unitCaster=="player" then
                for j=1,#db.buffFilterTargetMyDebuffs do
                    if db.buffFilterTargetMyDebuffs[j]==strlower(name) then
                        if expirationTime==0 then expirationTime = 66666*60 end -- so there isn't a huge negative number shown
                        
                        tempFrameList = frames["buffFilterTargetMyDebuffs"]
                        for k=1,#tempFrameList.list do
                            if not tempFrameList.list[k][3] then
                                temp2 = k
                                break
                            end
                        end
                        
                        tempFrameList.list[temp2][1] = name
                        tempFrameList.list[temp2][2] = rank
                        tempFrameList.list[temp2][3] = icon
                        tempFrameList.list[temp2][4] = count
                        tempFrameList.list[temp2][5] = debuffType
                        tempFrameList.list[temp2][6] = duration
                        tempFrameList.list[temp2][7] = expirationTime
                        tempFrameList.list[temp2][8] = unitCaster
                        tempFrameList.list[temp2][9] = isStealable
                        tempFrameList.list[temp2][10] = shouldConsolidate
                        tempFrameList.list[temp2][11] = spellId
                        tempFrameList.list[temp2][12] = index
                        tempFrameList.list[temp2][13] = filter
                        tempFrameList.list[temp2][14] = u
                        
                        temp = true
                        break
                    end
                end
            else
                for j=1,#db.buffFilterTargetOthersDebuffs do
                    if db.buffFilterTargetOthersDebuffs[j]==strlower(name) then
                        if expirationTime==0 then expirationTime = 66666*60 end -- so there isn't a huge negative number shown
                        
                        tempFrameList = frames["buffFilterTargetMyDebuffs"]
                        for k=1,#tempFrameList.list do
                            if not tempFrameList.list[k][3] then
                                temp2 = k
                                break
                            end
                        end
                        
                        tempFrameList.list[temp2][1] = name
                        tempFrameList.list[temp2][2] = rank
                        tempFrameList.list[temp2][3] = icon
                        tempFrameList.list[temp2][4] = count
                        tempFrameList.list[temp2][5] = debuffType
                        tempFrameList.list[temp2][6] = duration
                        tempFrameList.list[temp2][7] = expirationTime
                        tempFrameList.list[temp2][8] = unitCaster
                        tempFrameList.list[temp2][9] = isStealable
                        tempFrameList.list[temp2][10] = shouldConsolidate
                        tempFrameList.list[temp2][11] = spellId
                        tempFrameList.list[temp2][12] = index
                        tempFrameList.list[temp2][13] = filter
                        tempFrameList.list[temp2][14] = u
                        
                        temp = true
                        break
                    end
                end
            end
        end
        
        updateFramesList[tostring( frames["buffFilterTargetMyBuffs"] )] = frames["buffFilterTargetMyBuffs"]
        updateFramesList[tostring( frames["buffFilterTargetMyDebuffs"] )] = frames["buffFilterTargetMyDebuffs"]
    elseif unit and unit=="pet" and frames["buffFilterPet"] then --[[PET]]
        for i=1,8 do
            resetBuffTable(frames["buffFilterPet"].list[i])
        end
        
        for i=1,40 do
            if not auras[unit].HELPFUL[i][1] then
                break
            end
            temp = false
            
            name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId, index, filter, u = unpack( auras[unit].HELPFUL[i],1,14 )
            
            for j=1,#db.buffFilterPet do
                if db.buffFilterPet[j]==strlower(name) then
                    if expirationTime==0 then expirationTime = 66666*60 end -- so there isn't a huge negative number shown
                    
                    tempFrameList = frames["buffFilterPet"]
                    for k=1,#tempFrameList.list do
                        if not tempFrameList.list[k][3] then
                            temp2 = k
                            break
                        end
                    end
                    
                    tempFrameList.list[temp2][1] = name
                    tempFrameList.list[temp2][2] = rank
                    tempFrameList.list[temp2][3] = icon
                    tempFrameList.list[temp2][4] = count
                    tempFrameList.list[temp2][5] = debuffType
                    tempFrameList.list[temp2][6] = duration
                    tempFrameList.list[temp2][7] = expirationTime
                    tempFrameList.list[temp2][8] = unitCaster
                    tempFrameList.list[temp2][9] = isStealable
                    tempFrameList.list[temp2][10] = shouldConsolidate
                    tempFrameList.list[temp2][11] = spellId
                    tempFrameList.list[temp2][12] = index
                    tempFrameList.list[temp2][13] = filter
                    tempFrameList.list[temp2][14] = u
                    
                    temp = true
                    break
                end
            end
        end
        
        updateFramesList[tostring( frames["buffFilterPet"] )] = frames["buffFilterPet"]
        
    end
end

--[[ Buffs Update ]]
local function buffUpdate()
    for index,value in pairs(updateFramesList) do
        buffFrameUpdate(value)
        updateFramesList[index] = nil
    end
    
    local time = GetTime()
    
    for index,value in pairs(frames) do
        for i=1,#value do
            if value[i].index then
                temp = value[i].expirationTime or 99999*60
                
                if temp and temp<66666*60 then
                    value[i].time:SetText( formatTime( round( temp-time, 0 ) ) )
                    if value[i].bar then value[i].bar:SetValue( ( temp-time )/value[i].duration ) end
                else
                    value[i].time:SetText(nil)
                    if value[i].bar then value[i].bar:SetValue( 1 ) end
                end
            else
                break
            end
        end
    end
end

--[[ Create Buff Frames ]]
-- direction: UP,DOWN,LEFT
local function createBuffsLarge( name, unit, number, direction, width, color )
    if not color then
        color = { db.bgColor.r, db.bgColor.g, db.bgColor.b, db.bgColor.a }
    end
    
    local height = db.buffSize
    local width = width or db.width
    
    local buffSetup = {}
    for i=1,number do
        local buff = CreateFrame("Frame", "DocsUI_Auras_"..name..i, UIParent)
        buff:EnableMouse(true)
        buff:SetWidth(width)
        buff:SetHeight( height )
        if i>1 then
            if direction=="UP" then
                buff:SetPoint( "BOTTOMLEFT", buffSetup[i-1], "TOPLEFT", 0, db.buffSpacing )
            elseif direction=="LEFT" then
                buff:SetPoint( "TOPRIGHT", buffSetup[i-1], "TOPLEFT", -db.buffSpacing, 0 )
            else
                buff:SetPoint( "TOPLEFT", buffSetup[i-1], "BOTTOMLEFT", 0, -db.buffSpacing )
            end
        end
        DocsUI:setBorder( buff )
        
        local icon = buff:CreateTexture( nil, "OVERLAY" )
        icon:SetWidth( height )
        icon:SetHeight( height )
        icon:SetPoint( "LEFT", buff, "LEFT", 0, 0 )
        icon:SetTexCoord(0.1,0.9,0.1,0.9)
        buff.icon = icon
        
        local bar = CreateFrame("StatusBar", nil, buff)
        bar:SetPoint( "TOPLEFT", icon, "TOPRIGHT", 0, 0 )
        bar:SetPoint( "BOTTOMRIGHT", buff, "BOTTOMRIGHT", 0, 0 )
        --bar:SetWidth(width-db.spacingFixed*2-db.height)
        --bar:SetHeight(db.buffSize)
        bar:SetStatusBarTexture(LSM:Fetch("statusbar", db.texture))
        bar:SetStatusBarColor(color[1],color[2],color[3],color[4])
        bar:SetMinMaxValues(0,1)
        bar:SetValue(1)
        buff.bar = bar
        
        local bg = buff:CreateTexture(nil, "BORDER")
        bg:SetAllPoints(bar)
        bg:SetVertexColor(db.bgColor.r, db.bgColor.g, db.bgColor.b, db.bgColor.a)
        bg:SetTexture(LSM:Fetch("statusbar", db.texture))
        buff.bg = bg
        
        local time = buff:CreateFontString(nil, "OVERLAY", "GameFontNormal")
        time:SetParent( bar )
        time:SetFont(LSM:Fetch("font", db.fontb), db.fontsize)
        time:SetPoint("RIGHT", bar, "RIGHT", -db.spacingFixed, 0)
        time:SetJustifyH("RIGHT")
        time:SetJustifyV("CENTER")
        time:SetShadowColor(0,0,0,1)
        time:SetShadowOffset(1,-1)
        time:SetTextColor(db.fontColor.r,db.fontColor.g,db.fontColor.b,db.fontColor.a)
        buff.time = time
        
        local counter = buff:CreateFontString(nil, "OVERLAY", "GameFontNormal")
        counter:SetPoint("CENTER", icon, "LEFT", 0, 0)
        counter:SetFont(LSM:Fetch("font", db.fontb), db.fontsize-1, "OUTLINE")
        counter:SetJustifyH("CENTER")
        counter:SetJustifyV("CENTER")
        counter:SetShadowColor(0,0,0,1)
        counter:SetShadowOffset(1,-1)
        counter:SetTextColor(db.fontColor.r,db.fontColor.g,db.fontColor.b,db.fontColor.a)
        buff.counter = counter
        
        local text = bar:CreateFontString(nil, "OVERLAY", "GameFontNormal")
        text:SetPoint("LEFT", bar, "LEFT", db.spacingFixed, 0)
        text:SetPoint("RIGHT", time, "LEFT", 0, 0)
        text:SetFont(LSM:Fetch("font", db.font), db.fontsize-1)
        text:SetJustifyH("LEFT")
        text:SetJustifyV("CENTER")
        text:SetShadowColor(0,0,0,1)
        text:SetShadowOffset(1,-1)
        text:SetTextColor(db.fontColor.r,db.fontColor.g,db.fontColor.b,db.fontColor.a)
        buff.text = text
        
        buff:SetScript("OnEnter", function(self)
                                    if not self:IsVisible() or not self.unit or not self.index or not self.filter then return end
                                    
                                    GameTooltip:SetOwner(self, "ANCHOR_TOP", 10, 5)
                                    GameTooltip:SetUnitAura(self.unit, self.index, self.filter)
                                end)
        buff:SetScript("OnLeave", function() GameTooltip:Hide() end)
        buff:SetScript("OnMouseUp", function(self, button) if button=="RightButton" then CancelUnitBuff("player", self.index, self.filter) end end)
        
        buff:Hide()
        tinsert( buffSetup, buff )
    end
    
    buffSetup.unit = unit
    buffSetup.name = name
    buffSetup.size = size
    buffSetup.list = {}
    for i=1,number do
        buffSetup.list[i] = {}
    end
    
    frames[name] = buffSetup
end

local function createBuffsSmall(name, unit, number, direction, width, color)
    if not color then
        color = { db.bgColor.r, db.bgColor.g, db.bgColor.b, db.bgColor.a }
    end
    
    local height = db.buffSize
    local width = width or db.width/3
    
    local buffSetup = {}
    for i=1,number do
        local buff = CreateFrame("Frame", "DocsUI_Auras_"..name..i, UIParent)
        buff:EnableMouse(true)
        buff:SetWidth(width)
        buff:SetHeight( height )
        if i>1 then
            if direction=="UP" then
                buff:SetPoint( "BOTTOMLEFT", buffSetup[i-1], "TOPLEFT", 0, db.buffSpacing )
            elseif direction=="LEFT" then
                buff:SetPoint( "TOPRIGHT", buffSetup[i-1], "TOPLEFT", -db.buffSpacing, 0 )
            else
                buff:SetPoint( "TOPLEFT", buffSetup[i-1], "BOTTOMLEFT", 0, -db.buffSpacing )
            end
        end
        DocsUI:setBorder( buff )
        
        local icon = buff:CreateTexture( nil, "OVERLAY" )
        icon:SetWidth( height )
        icon:SetHeight( height )
        icon:SetPoint( "LEFT", buff, "LEFT", 0, 0 )
        icon:SetTexCoord(0.1,0.9,0.1,0.9)
        buff.icon = icon
        
        local bar = CreateFrame("StatusBar", nil, buff)
        bar:SetPoint( "TOPLEFT", icon, "TOPRIGHT", 0, 0 )
        bar:SetPoint( "BOTTOMRIGHT", buff, "BOTTOMRIGHT", 0, 0 )
        --bar:SetWidth(width-db.spacingFixed*2-db.height)
        --bar:SetHeight(db.buffSize)
        bar:SetStatusBarTexture(LSM:Fetch("statusbar", db.texture))
        bar:SetStatusBarColor(color[1],color[2],color[3],color[4])
        bar:SetMinMaxValues(0,1)
        bar:SetValue(1)
        buff.bar = bar
        
        local bg = buff:CreateTexture(nil, "BORDER")
        bg:SetAllPoints(bar)
        bg:SetVertexColor(db.bgColor.r, db.bgColor.g, db.bgColor.b, db.bgColor.a)
        bg:SetTexture(LSM:Fetch("statusbar", db.texture))
        buff.bg = bg
        
        local time = buff:CreateFontString(nil, "OVERLAY", "GameFontNormal")
        time:SetParent( bar )
        time:SetFont(LSM:Fetch("font", db.font), db.fontsize)
        time:SetPoint("RIGHT", bar, "RIGHT", -db.spacingFixed, 0)
        time:SetJustifyH("RIGHT")
        time:SetJustifyV("CENTER")
        time:SetShadowColor(0,0,0,1)
        time:SetShadowOffset(1,-1)
        time:SetTextColor(db.fontColor.r,db.fontColor.g,db.fontColor.b,db.fontColor.a)
        buff.time = time
        
        local counter = buff:CreateFontString(nil, "OVERLAY", "GameFontNormal")
        counter:SetPoint("CENTER", icon, "LEFT", 0, 0)
        counter:SetFont(LSM:Fetch("font", db.fontb), db.fontsize-1, "OUTLINE")
        counter:SetJustifyH("CENTER")
        counter:SetJustifyV("CENTER")
        counter:SetShadowColor(0,0,0,1)
        counter:SetShadowOffset(1,-1)
        counter:SetTextColor(db.fontColor.r,db.fontColor.g,db.fontColor.b,db.fontColor.a)
        buff.counter = counter
        
        buff:SetScript("OnEnter", function(self)
                                    if not self:IsVisible() or not self.unit or not self.index or not self.filter then return end
                                    
                                    GameTooltip:SetOwner(self, "ANCHOR_TOP", 10, 5)
                                    GameTooltip:SetUnitAura(self.unit, self.index, self.filter)
                                end)
        buff:SetScript("OnLeave", function() GameTooltip:Hide() end)
        buff:SetScript("OnMouseUp", function(self, button) if button=="RightButton" then CancelUnitBuff("player", self.index, self.filter) end end)
        
        buff:Hide()
        tinsert(buffSetup, buff)
    end
    
    buffSetup.unit = unit
    buffSetup.name = name
    buffSetup.size = size
    buffSetup.list = {}
    for i=1,number do
        buffSetup.list[i] = {}
    end
    
    frames[name] = buffSetup
end

local function createBuffsIcon(name, unit, number, direction, width, color)
    if not color then
        color = { db.bgColor.r, db.bgColor.g, db.bgColor.b, db.bgColor.a }
    end
    
    local height = db.buffSize
    local width = width or db.buffSize
    
    local buffSetup = {}
    for i=1,number do
        local buff = CreateFrame("Frame", "DocsUI_Auras_"..name..i, UIParent)
        buff:EnableMouse(true)
        buff:SetWidth(width)
        buff:SetHeight( height )
        if i>1 then
            if direction=="UP" then
                buff:SetPoint( "BOTTOMLEFT", buffSetup[i-1], "TOPLEFT", 0, db.buffSpacing )
            elseif direction=="LEFT" then
                buff:SetPoint( "TOPRIGHT", buffSetup[i-1], "TOPLEFT", -db.buffSpacing, 0 )
            else
                buff:SetPoint( "TOPLEFT", buffSetup[i-1], "BOTTOMLEFT", 0, -db.buffSpacing )
            end
        end
        DocsUI:setBorder( buff )
        
        local icon = buff:CreateTexture( nil, "OVERLAY" )
        icon:SetWidth( height )
        icon:SetHeight( height )
        icon:SetPoint( "LEFT", buff, "LEFT", 0, 0 )
        icon:SetTexCoord(0.1,0.9,0.1,0.9)
        buff.icon = icon
        
        local time = buff:CreateFontString(nil, "OVERLAY", "GameFontNormal")
        time:SetFont(LSM:Fetch("font", db.font), db.fontsize-2, "OUTLINE")
        time:SetPoint( "CENTER", icon, "BOTTOM", 0, 0 )
        time:SetJustifyH("CENTER")
        time:SetJustifyV("CENTER")
        time:SetShadowColor(0,0,0,1)
        time:SetShadowOffset(1,-1)
        time:SetTextColor(db.fontColor.r,db.fontColor.g,db.fontColor.b,db.fontColor.a)
        buff.time = time
        
        local counter = buff:CreateFontString(nil, "OVERLAY", "GameFontNormal")
        counter:SetPoint("CENTER", icon, "TOP", 0, 0)
        counter:SetFont(LSM:Fetch("font", db.fontb), db.fontsize-1, "OUTLINE")
        counter:SetJustifyH("CENTER")
        counter:SetJustifyV("CENTER")
        counter:SetShadowColor(0,0,0,1)
        counter:SetShadowOffset(1,-1)
        counter:SetTextColor(db.fontColor.r,db.fontColor.g,db.fontColor.b,db.fontColor.a)
        buff.counter = counter
        
        buff:SetScript("OnEnter", function(self)
                                    if not self:IsVisible() or not self.unit or not self.index or not self.filter then return end
                                    
                                    GameTooltip:SetOwner(self, "ANCHOR_TOP", 10, 5)
                                    GameTooltip:SetUnitAura(self.unit, self.index, self.filter)
                                end)
        buff:SetScript("OnLeave", function() GameTooltip:Hide() end)
        buff:SetScript("OnMouseUp", function(self, button) if button=="RightButton" then CancelUnitBuff("player", self.index, self.filter) end end)
        
        buff:Hide()
        tinsert(buffSetup, buff)
    end
    
    buffSetup.unit = unit
    buffSetup.name = name
    buffSetup.size = size
    buffSetup.list = {}
    for i=1,number do
        buffSetup.list[i] = {}
    end
    
    frames[name] = buffSetup
end

local function createBuffsDebuffs( name, unit, number, direction, width, color )
    if not color then
        color = { db.bgColor.r, db.bgColor.g, db.bgColor.b, db.bgColor.a }
    end
    
    local height = db.buffSize
    local width = width or db.width
    local numberLargeBuffs = 2
    
    local buffSetup = {}
    for i=1,numberLargeBuffs do
        local buff = CreateFrame("Frame", "DocsUI_Auras_"..name..i, UIParent)
        buff:EnableMouse(true)
        buff:SetWidth( width )
        buff:SetHeight( height )
        if i>1 then
            if direction=="UP" then
                buff:SetPoint( "BOTTOMLEFT", buffSetup[i-1], "TOPLEFT", 0, db.buffSpacing )
            else
                buff:SetPoint( "TOPLEFT", buffSetup[i-1], "BOTTOMLEFT", 0, -db.buffSpacing )
            end
        end
        DocsUI:setBorder( buff )
        
        local icon = buff:CreateTexture( nil, "OVERLAY" )
        icon:SetWidth( height )
        icon:SetHeight( height )
        icon:SetPoint( "LEFT", buff, "LEFT", 0, 0 )
        icon:SetTexCoord(0.1,0.9,0.1,0.9)
        buff.icon = icon
        
        local bar = CreateFrame( "StatusBar", nil, buff )
        --bar:SetWidth( width-height )
        --bar:SetHeight( height )
        --bar:SetPoint( "RIGHT", buff, "RIGHT", 0, 0 )
        bar:SetPoint( "TOPLEFT", icon, "TOPRIGHT", 0, 0 )
        bar:SetPoint( "BOTTOMRIGHT", buff, "BOTTOMRIGHT", 0, 0 )
        bar:SetStatusBarTexture(LSM:Fetch("statusbar", db.texture))
        bar:SetStatusBarColor(color[1],color[2],color[3],color[4])
        bar:SetMinMaxValues( 0, 1 )
        bar:SetValue( 1 )
        buff.bar = bar
        
        local bg = bar:CreateTexture(nil, "BORDER")
        bg:SetAllPoints(bar)
        bg:SetVertexColor(db.bgColor.r, db.bgColor.g, db.bgColor.b, db.bgColor.a)
        bg:SetTexture(LSM:Fetch("statusbar", db.texture))
        buff.bg = bg
        
        local time = buff:CreateFontString(nil, "OVERLAY", "GameFontNormal")
        time:SetParent( bar )
        time:SetFont(LSM:Fetch("font", db.fontb), db.fontsize)
        time:SetPoint("RIGHT", bar, "RIGHT", -db.spacingFixed, 0)
        time:SetJustifyH("RIGHT")
        time:SetJustifyV("CENTER")
        time:SetShadowColor(0,0,0,1)
        time:SetShadowOffset(1,-1)
        time:SetTextColor(db.fontColor.r,db.fontColor.g,db.fontColor.b,db.fontColor.a)
        buff.time = time
        
        local counter = buff:CreateFontString(nil, "OVERLAY", "GameFontNormal")
        counter:SetPoint("CENTER", icon, "LEFT", 0, 0)
        counter:SetFont(LSM:Fetch("font", db.fontb), db.fontsize-1, "OUTLINE")
        counter:SetJustifyH("CENTER")
        counter:SetJustifyV("CENTER")
        counter:SetShadowColor(0,0,0,1)
        counter:SetShadowOffset(1,-1)
        counter:SetTextColor(db.fontColor.r,db.fontColor.g,db.fontColor.b,db.fontColor.a)
        buff.counter = counter
        
        local text = bar:CreateFontString(nil, "OVERLAY", "GameFontNormal")
        text:SetPoint("LEFT", bar, "LEFT", db.spacingFixed, 0)
        text:SetPoint("RIGHT", time, "LEFT", 0, 0)
        text:SetFont(LSM:Fetch("font", db.font), db.fontsize-1)
        text:SetJustifyH("LEFT")
        text:SetJustifyV("CENTER")
        text:SetShadowColor(0,0,0,1)
        text:SetShadowOffset(1,-1)
        text:SetTextColor(db.fontColor.r,db.fontColor.g,db.fontColor.b,db.fontColor.a)
        buff.text = text
        
        buff:SetScript("OnEnter", function(self)
                                    if not self:IsVisible() or not self.unit or not self.index or not self.filter then return end
                                    
                                    GameTooltip:SetOwner(self, "ANCHOR_TOP", 10, 5)
                                    GameTooltip:SetUnitAura(self.unit, self.index, self.filter)
                                end)
        buff:SetScript("OnLeave", function() GameTooltip:Hide() end)
        buff:SetScript("OnMouseUp", function(self, button) if button=="RightButton" then CancelUnitBuff("player", self.index, self.filter) end end)
        
        buff:Hide()
        tinsert( buffSetup, buff )
    end
    
    local height = db.buffSize
    local width = width or db.buffSize
    
    for i=numberLargeBuffs+1,number do
        local buff = CreateFrame("Frame", "DocsUI_Auras_"..name..i, UIParent)
        buff:EnableMouse(true)
        buff:SetWidth( height )
        buff:SetHeight( height )
        if i==numberLargeBuffs+1 then
            if direction=="UP" then
                buff:SetPoint( "BOTTOMLEFT", buffSetup[i-1], "TOPLEFT", 0, db.buffSpacing*2 )
            else
                buff:SetPoint( "TOPLEFT", buffSetup[i-1], "BOTTOMLEFT", 0, -db.buffSpacing*2 )
            end
        elseif i==numberLargeBuffs+1+5 then
            if direction=="UP" then
                buff:SetPoint( "BOTTOMLEFT", buffSetup[i-5], "TOPLEFT", 0, db.buffSpacing*2 )
            else
                buff:SetPoint( "TOPLEFT", buffSetup[i-5], "BOTTOMLEFT", 0, -db.buffSpacing*2 )
            end
        else
            buff:SetPoint( "LEFT", buffSetup[i-1], "RIGHT", db.buffSpacing, 0 )
        end
        DocsUI:setBorder( buff )
        
        local icon = buff:CreateTexture( nil, "OVERLAY" )
        icon:SetWidth( height )
        icon:SetHeight( height )
        icon:SetPoint( "LEFT", buff, "LEFT", 0, 0 )
        icon:SetTexCoord(0.1,0.9,0.1,0.9)
        buff.icon = icon
        
        local time = buff:CreateFontString(nil, "OVERLAY", "GameFontNormal")
        time:SetFont(LSM:Fetch("font", db.font), db.fontsize-2, "OUTLINE")
        time:SetPoint( "CENTER", icon, "BOTTOM", 0, 0 )
        time:SetJustifyH("CENTER")
        time:SetJustifyV("CENTER")
        time:SetShadowColor(0,0,0,1)
        time:SetShadowOffset(1,-1)
        time:SetTextColor(db.fontColor.r,db.fontColor.g,db.fontColor.b,db.fontColor.a)
        buff.time = time
        
        local counter = buff:CreateFontString(nil, "OVERLAY", "GameFontNormal")
        counter:SetPoint("CENTER", icon, "TOP", 0, 0)
        counter:SetFont(LSM:Fetch("font", db.fontb), db.fontsize-1, "OUTLINE")
        counter:SetJustifyH("CENTER")
        counter:SetJustifyV("CENTER")
        counter:SetShadowColor(0,0,0,1)
        counter:SetShadowOffset(1,-1)
        counter:SetTextColor(db.fontColor.r,db.fontColor.g,db.fontColor.b,db.fontColor.a)
        buff.counter = counter
        
        buff:SetScript("OnEnter", function(self)
                                    if not self:IsVisible() or not self.unit or not self.index or not self.filter then return end
                                    
                                    GameTooltip:SetOwner(self, "ANCHOR_TOP", 10, 5)
                                    GameTooltip:SetUnitAura(self.unit, self.index, self.filter)
                                end)
        buff:SetScript("OnLeave", function() GameTooltip:Hide() end)
        buff:SetScript("OnMouseUp", function(self, button) if button=="RightButton" then CancelUnitBuff("player", self.index, self.filter) end end)
        
        buff:Hide()
        tinsert( buffSetup, buff )
    end
    
    buffSetup.unit = unit
    buffSetup.name = name
    buffSetup.size = size
    buffSetup.list = {}
    for i=1,number do
        buffSetup.list[i] = {}
    end
    
    frames[name] = buffSetup
end

--[[ onUpdate ]]
local frameUpdate = CreateFrame("Frame", nil, UIParent)
local lastUpdate = 0
local function onUpdate(self, elapsed)
	lastUpdate = lastUpdate + elapsed
	
	if lastUpdate > db.updateSpeedAuras then
		lastUpdate = 0
		
        buffUpdate()
	end
end
frameUpdate:SetScript("OnUpdate", onUpdate)

-- Update Auras
function DocsUI:DoUpdateAuras( unit )
    scan( unit )
end

-- Spawn Buff Frames
function DocsUI:SpawnBuffFrames()
    db = DocsUI.db.profile
    
    auras = DocsUI_AuraScanner.auras
    
    tinsert( DocsUI_AuraScanner.doUpdateAuras, DocsUI.DoUpdateAuras )
    
    frames = {}
    
    local color = { db.fgColor.r, db.fgColor.g, db.fgColor.b, db.fgColor.a }
    
    createBuffsIcon("buffs", "player", 30, "LEFT", nil, color)
    frames["buffs"][1]:ClearAllPoints()
    frames["buffs"][1]:ClearAllPoints()
    frames["buffs"][1]:SetPoint( "TOPRIGHT", Minimap, "TOPLEFT", -db.edgeDistance, 0 )
    
    createBuffsIcon("buffFilterPlayerRaidBuffs", "player", 30, "LEFT", nil, color)
    frames["buffFilterPlayerRaidBuffs"][1]:ClearAllPoints()
    frames["buffFilterPlayerRaidBuffs"][1]:SetPoint( "TOPRIGHT", frames["buffs"][1], "BOTTOMRIGHT", 0, -db.spacingFixed*8 )
    
    createBuffsDebuffs("debuffs", "player", 8, "UP", nil, {1,0,0,0.75})
    frames["debuffs"][1]:ClearAllPoints()
    frames["debuffs"][1]:SetPoint( "BOTTOMRIGHT", DocsUI.oUFplayer, "TOPRIGHT", 0, db.spacingFixed*4 )
    
    createBuffsIcon("buffFilterPlayerShort", "player", 8, "DOWN", nil, color)
    frames["buffFilterPlayerShort"][1]:ClearAllPoints()
    frames["buffFilterPlayerShort"][1]:SetPoint( "TOPRIGHT", DocsUI.oUFanchor, "BOTTOMRIGHT", 0, -db.spacingFixed*16 )
    
    createBuffsIcon("buffFilterPlayerLong", "player", 8, "DOWN", nil, color)
    frames["buffFilterPlayerLong"][1]:ClearAllPoints()
    frames["buffFilterPlayerLong"][1]:SetPoint( "TOPLEFT", DocsUI.oUFanchor, "BOTTOMLEFT", 0, -db.spacingFixed*16 )
    
    createBuffsSmall("buffFilterTargetMyDebuffs", "target", 8, "UP", nil, color)
    frames["buffFilterTargetMyDebuffs"][1]:ClearAllPoints()
    frames["buffFilterTargetMyDebuffs"][1]:SetPoint( "BOTTOMLEFT", DocsUI.oUFtarget, "TOPLEFT", 0, db.spacingFixed*4 )
    
    createBuffsSmall("buffFilterTargetMyBuffs", "target", 8, "UP", nil, color)
    frames["buffFilterTargetMyBuffs"][1]:ClearAllPoints()
    frames["buffFilterTargetMyBuffs"][1]:SetPoint( "BOTTOMRIGHT", DocsUI.oUFtarget, "TOPRIGHT", 0, db.spacingFixed*4 )
    
    --createBuffsSmall("buffFilterTargetOthersBuffs", "target", 8, "UP", nil, color)
    --frames["buffFilterTargetOthersBuffs"][1]:ClearAllPoints()
    --frames["buffFilterTargetOthersBuffs"][1]:SetPoint("BOTTOMLEFT", DocsUI.oUFtargettarget, "TOPLEFT", 0, db.spacingFixed*2)
    
    createBuffsIcon("buffFilterPet", "pet", 8, "DOWN", nil, color)
    frames["buffFilterPet"][1]:ClearAllPoints()
    frames["buffFilterPet"][1]:SetPoint("TOPLEFT", DocsUI.oUFpet, "BOTTOMLEFT", 0, -db.spacingFixed*4)
    
    BuffFrame:Hide()
    BuffFrame:SetScript("OnEvent", nil)
    BuffFrame:SetScript("OnUpdate", nil)
    TemporaryEnchantFrame:Hide()
    TemporaryEnchantFrame:SetScript("OnUpdate", nil)
    TempEnchant1:SetScript("OnUpdate", nil)
    TempEnchant2:SetScript("OnUpdate", nil)
end

--test
function DocsUI:auraTest()
    frames["buffs"][1]:ClearAllPoints()
    frames["buffs"][1]:ClearAllPoints()
    frames["buffs"][1]:SetPoint( "TOPRIGHT", UIParent, "TOPRIGHT", -db.edgeDistance, -db.edgeDistance )
    
    frames["buffFilterPlayerRaidBuffs"][1]:ClearAllPoints()
    frames["buffFilterPlayerRaidBuffs"][1]:SetPoint( "TOPRIGHT", frames["buffs"][1], "BOTTOMRIGHT", 0, -db.spacingFixed*8 )
    DocsAurasBuffs = frames["buffFilterPlayerRaidBuffs"][1]
    
    frames["debuffs"][1]:ClearAllPoints()
    frames["debuffs"][1]:SetPoint( "BOTTOMRIGHT", DocsOUFplayer, "TOPRIGHT", 0, db.spacingFixed*4*2+db.height*2 )
    
    frames["buffFilterPlayerShort"][1]:ClearAllPoints()
    frames["buffFilterPlayerShort"][1]:SetPoint( "TOPRIGHT", DocsOUFanchor, "BOTTOMRIGHT", 0, -db.spacingFixed*4 )
    
    frames["buffFilterPlayerLong"][1]:ClearAllPoints()
    frames["buffFilterPlayerLong"][1]:SetPoint( "TOPLEFT", DocsOUFanchor, "BOTTOMLEFT", 0, -db.spacingFixed*4 )
    
    frames["buffFilterTargetMyDebuffs"][1]:ClearAllPoints()
    frames["buffFilterTargetMyDebuffs"][1]:SetPoint( "BOTTOMLEFT", DocsOUFtarget, "TOPLEFT", 0, db.spacingFixed*4 )
    
    frames["buffFilterTargetMyBuffs"][1]:ClearAllPoints()
    frames["buffFilterTargetMyBuffs"][1]:SetPoint( "BOTTOMRIGHT", DocsOUFtarget, "TOPRIGHT", 0, db.spacingFixed*4 )
    
    --createBuffFrame("buffFilterTargetOthersBuffs", "target", 8, "UP", "SMALL, color")
    --frames["buffFilterTargetOthersBuffs"][1]:ClearAllPoints()
    --frames["buffFilterTargetOthersBuffs"][1]:SetPoint("BOTTOMLEFT", DocsOUFtot, "TOPLEFT", 0, db.spacingFixed*2)
    
    frames["buffFilterPet"][1]:ClearAllPoints()
    frames["buffFilterPet"][1]:SetPoint("BOTTOMLEFT", DocsOUFpet, "TOPLEFT", 0, db.spacingFixed*4)
    
    BuffFrame:Hide()
    BuffFrame:SetScript("OnEvent", nil)
    BuffFrame:SetScript("OnUpdate", nil)
    TemporaryEnchantFrame:Hide()
    TemporaryEnchantFrame:SetScript("OnUpdate", nil)
    TempEnchant1:SetScript("OnUpdate", nil)
    TempEnchant2:SetScript("OnUpdate", nil)
end