﻿--[[
	Copyright (c) 2009, dr_AllCOM3
    All rights reserved.

    You're allowed to use this addon, free of monetary charge,
    but you are not allowed to modify, alter, or redistribute
    this addon without express, written permission of the author.
]]

local L = LibStub("AceLocale-3.0"):GetLocale("DocsUI")
local LSM = LibStub("LibSharedMedia-3.0")
local db
local temp, temp2 = nil

--[[ Print ]]
local function p( text )
	ChatFrame3:AddMessage( tostring( text ) )
end

local updateLater = false
local doUpdateAuras = nil

-- On Command
function DocsUI:Command(param)
	if param=="gm" then
		ToggleHelpFrame()
	else
		InterfaceOptionsFrame_OpenToCategory("DocsUI")
	end
end
function DocsUI:GM(param)
    ToggleHelpFrame()
end

-- OnInitialize
function DocsUI:OnInitialize()
    -- DB
	self.db = LibStub("AceDB-3.0"):New("DocsUIDB", self.defaults)
    db = DocsUI.db.profile
    
    -- Options
    self:SpawnOptions()
    LibStub("AceConfig-3.0"):RegisterOptionsTable("DocsUI", DocsUI.options)
    LibStub("AceConfigDialog-3.0"):AddToBlizOptions("DocsUI", "DocsUI")
    
    -- Profile options
    local AceDBOptions = LibStub("AceDBOptions-3.0", true)
	if AceDBOptions then
		self.options.args.profiles = AceDBOptions:GetOptionsTable(self.db)
		self.options.args.profiles.order = 999
	end
    
    -- Command
    self:RegisterChatCommand("docsui", "Command")
    self:RegisterChatCommand("du", "Command")
    self:RegisterChatCommand("gm", "GM")
    
    LSM:Register("font", "_DocsUIfont",					[[Interface\Addons\DocsUI\media\font.ttf]])
    LSM:Register("font", "_DocsUIfontb",					[[Interface\Addons\DocsUI\media\fontb.ttf]])
    LSM:Register("font", "_DocsUIfonti",					[[Interface\Addons\DocsUI\media\fonti.ttf]])
    LSM:Register("statusbar", "_DocsUIstatusbar",			[[Interface\Addons\DocsUI\media\statusbar]])
end
-- OnEnable
function DocsUI:OnEnable()
    self:RegisterEvent("RAID_ROSTER_UPDATE")
    self:RegisterEvent("PLAYER_LOGIN")
    self:RegisterEvent("PLAYER_REGEN_ENABLED")
    self:RegisterEvent("UNIT_AURA")
    
    self:RegisterEvent("WORLD_STATE_UI_TIMER_UPDATE")
    self:RegisterEvent("ZONE_CHANGED")
	self:RegisterEvent("ZONE_CHANGED_INDOORS")
	self:RegisterEvent("ZONE_CHANGED_NEW_AREA")
    
    if type(self.SpawnSettings) then self:SpawnSettings() end
    if type(self.SpawnImportWindow) then self:SpawnImportWindow() end
    
    if type( self.SpawnOuf )=="function" then self:SpawnOuf() end -- and SpawnBuffFrames
    
    if type(self.SpawnMinimap)=="function" then self:SpawnMinimap() end
    if type(self.SpawnActionbars)=="function" then self:SpawnActionbars() end
    if type(self.SpawnFonts)=="function" then self:SpawnFonts() end
    
    doUpdateAuras = nil or DocsUI.DoUpdateAuras
    
    -- Import
    if db.version<self.version then
        db.version = self.version
        DocsUI.importWindow:Show()
    end
    
    -- Bugfix
--~     if db.version and db.version<DocsUI.version then
--~         DocsUI:Bugfix()
--~     end
end
function DocsUI:OnDisable()
	
end

-- UNIT_AURA
function DocsUI:UNIT_AURA(self, unit)
    if not unit or not doUpdateAuras then return end
    
    if unit=="player" or unit=="target" or unit=="pet" or unit=="vehicle" or unit=="mouseover" or strfind(unit, "raid") or strfind(unit, "party") then
        --doUpdateAuras(unit, unit)
    end
end
-- PLAYER_LOGIN
function DocsUI:PLAYER_LOGIN()
    if UnitAffectingCombat("player") then
        updateLater = true
    else
        if type(DocsUI.UpdatePartyFrames)=="function" then DocsUI:UpdatePartyFrames() end
        if type(DocsUI.UpdateRaidFrames)=="function" then DocsUI:UpdateRaidFrames() end
    end
    
    if type(DocsUI.UpdateAttempts)=="function" then DocsUI:UpdateAttempts() end
end
-- RAID_ROSTER_UPDATE
function DocsUI:RAID_ROSTER_UPDATE()
    if UnitAffectingCombat("player") then
        updateLater = true
    else
        if type(DocsUI.UpdatePartyFrames)=="function" then DocsUI:UpdatePartyFrames() end
        if type(DocsUI.UpdateRaidFrames)=="function" then DocsUI:UpdateRaidFrames() end
    end
end

-- PLAYER_REGEN_ENABLED
function DocsUI:PLAYER_REGEN_ENABLED(self)
    if updateLater then
        updateLater = false
        
        if type(DocsUI.UpdatePartyFrames)=="function" then DocsUI:UpdatePartyFrames() end
        if type(DocsUI.UpdateRaidFrames)=="function" then DocsUI:UpdateRaidFrames() end
    end
end

-- WORLD_STATE_UI_TIMER_UPDATE
function DocsUI:WORLD_STATE_UI_TIMER_UPDATE(self)
    
end

-- ZONE_CHANGED
function DocsUI:ZONE_CHANGED(self)
    
end

-- ZONE_CHANGED_INDOORS
function DocsUI:ZONE_CHANGED_INDOORS(self)
    
end

-- ZONE_CHANGED_NEW_AREA
function DocsUI:ZONE_CHANGED_NEW_AREA(self)
    
end

--[[ Print ]]
function DocsUI:p(text)
	ChatFrame1:AddMessage(tostring(text))
end

--[[ Copy table ]]
function DocsUI:Deepcopy(object)
    local lookup_table = {}
    local function _copy(object)
        if type(object) ~= "table" then
            return object
        elseif lookup_table[object] then
            return lookup_table[object]
        end
        local new_table = {}
        lookup_table[object] = new_table
        for index, value in pairs(object) do
            new_table[_copy(index)] = _copy(value)
        end
        return setmetatable(new_table, getmetatable(object))
    end
    return _copy(object)
end

--[[ Bugfix ]]
function DocsUI:Bugfix()
	temp = false
    
    if db.version<self.version then
        db.version = self.version
        
        --temp = true
    end
    
    if temp then
        StaticPopup_Show("reloadUi")
    end
end

--[[ Debug mode ]]
function DocsUI:d()
	db.debugMode = not db.debugMode
    DocsUI:p(tostring(db.debugMode))
end

--[[ Test ]]
local function test()
	local mult = ( 768/GetScreenHeight() )/GetCVar( "uiScale" )
    local function scale(x) return mult*x end
    
    p( scale(100) )
    
    --[[SetCVar( "uiScale", 1 )
    RestartGx()
    p( "screen: ".. GetScreenHeight() )
    p( "scale: ".. 768/GetScreenHeight() )
    SetCVar( "uiScale", 768/GetScreenHeight() )
    p( GetCVar( "uiScale" ) )
    RestartGx()]]
end
DocsUI.test = test
