﻿--[[
	Copyright (c) 2009, dr_AllCOM3
    All rights reserved.

    You're allowed to use this addon, free of monetary charge,
    but you are not allowed to modify, alter, or redistribute
    this addon without express, written permission of the author.
]]

local L = LibStub("AceLocale-3.0"):GetLocale("DocsUI")
local LSM = LibStub("LibSharedMedia-3.0")
local db
local temp,temp2 = nil

--[[ Print ]]
local function p( text )
	ChatFrame3:AddMessage( tostring( text ) )
end

temp = {GetScreenResolutions()}
temp = temp[GetCurrentResolution()]
local resolutionX, resolutionY = strsplit("x", temp)
local scale = UIParent:GetScale()
resolutionX = resolutionX*scale
resolutionY = resolutionY*scale

DocsUI.version = 4.01
DocsUI.defaults = { profile = {
    version = -1,
    logo = "Interface\\Addons\\DocsUI\\media\\logo",
    import = -1,
    debugMode = false,
    
    -- Options
    runeBarsShow = true,
    raidShow = true,
    
    spacingFixed = 2,
    width = 180,
    width2 = 80,
    height = 36,
    heightSmall = 6,
    edgeDistance = 15,
    buffSize = 16,
    buffSpacing = 6,
    iconSize = 24,
    
    fontsize = 14,
    
    barAlpha = 0.33,
    fgColor = {r=1/5,g=1/5,b=1/5,a=1},
    bgColor = {r=1/16,g=1/16,b=1/16,a=0.5},
    threatColor = { r=255/255, g=127/255, b=39/255, a=1 },
    castColor = { r=255/255, g=201/255, b=14/255, a=1 },
    
    bg = "Interface\\Addons\\DocsUI\\media\\bg1",
    texture = "_DocsUIstatusbar",
    
    
    declineDuels = false,
    presenceWarner = true,
    
    -- Old Options
    
    
    
    horizontal = 0,
    vertical = resolutionY*(2/7),
    
    inset = 0,
    spacing = 2,
    
    
    
    
    
    tileSize = 16,
    border = "Interface\\Addons\\DocsUI\\media\\border1",
    borderLarge = "Interface\\Addons\\DocsUI\\media\\borderLarge1",
    borderTex = 0,
    borderColor = {r=0,g=0,b=0,a=1},
    backdrop = {
            bgFile = bg, tile = true, tileSize = tileSize,
            edgeFile = nil, edgeSize = 16,
            insets = {left = inset, right = inset, top = inset, bottom = inset},
    },
    font = "_DocsUIfont",
    fonti = "_DocsUIfonti",
    fontb = "_DocsUIfontb",
    
    fontColor = {r=0.75,g=0.75,b=0.75,a=1},
    fontoffset = 0,
    
    textureComboPoint1 = "Interface\\Addons\\DocsUI\\media\\combo1",
    textureComboPoint2 = "Interface\\Addons\\DocsUI\\media\\combo2",
    textureComboPoint3 = "Interface\\Addons\\DocsUI\\media\\combo3",
    textureComboPoint4 = "Interface\\Addons\\DocsUI\\media\\combo4",
    textureComboPoint5 = "Interface\\Addons\\DocsUI\\media\\combo5",
    
    -- Unit Frames
    classIcon = true,
    roleIcon = true,
    
    
    castbarHider = { L["Close"] },
    raidFrameMode = "small", -- "small", "big", "healer", "disabled"
    raidSize = 14,
    
    raidStyle = L["Small Grid"],
    raidStyleList = { L["Close"], L["Small Grid"], L["Large List"] },
    partyShow = true,
    
    -- Actionbars
    mainBar = true,
    mainBarMouseover = false,
    mainBarScale = 0.75,
    secondBar = true,
    secondBarMouseover = false,
    secondBarScale = 0.75,
    thirdBar = true,
    thirdBarMouseover = false,
    thirdBarScale = 0.75,
    right1Bar = true,
    right1BarMouseover = false,
    right1BarScale = 0.75,
    petBar = true,
    petBarMouseover = false,
    shapeshiftBar = true,
    shapeshiftBarMouseover = false,
    
    -- Error Spam
    errorFilterList = { L["Close"] },
    
    -- Tooltip
    tooltipAnchor = L["Right"],
    tooltipAnchorList = { L["Close"], L["Right"], L["Mouse"] },
    dontShowTargetTooltip = false,
    
    -- Misc
    tooltipBgAlpha = 0.5,
    
    updateSpeedMinimap = 1,
    
    
    
    -- Auras
    updateSpeedAuras = 0.1,
    buffFilterPlayerShort = { L["Close"] },
    buffFilterPlayerLong = { L["Close"] },
    buffFilterPlayerRaidBuffs = { L["Close"] },
    buffFilterPlayerDebuffs = { L["Close"] },
    buffFilterTargetMyDebuffs = { L["Close"] },
    buffFilterTargetMyBuffs = { L["Close"] },
    buffFilterTargetOthersBuffs = { L["Close"] },
    buffFilterTargetOthersDebuffs = { L["Close"] },
    buffFilterPet = { L["Close"] },
} }

local db = DocsUI.defaults.profile

local castbarHider = {
    67322, --Submerge
}
for i=1,#castbarHider do
    temp = GetSpellInfo(castbarHider[i])
    temp = strlower(temp)
    tinsert(db.castbarHider, temp)
end

local errorFilterList = {
    L["not enough"],
    L["cannot attack"],
    L["out of range"],
    L["line of sight"],
    L["far away"],
    L["not ready"],
    L["no target"],
    L["can't do that yet"],
    L["target is dead"],
    L["nothing to attack"],
    L["facing"],
    L["fleeing"],
    L["stunned"],
    L["you are dead"],
    L["action in"],
    L["another action"],
}
for i=1,#errorFilterList do
    temp = errorFilterList[i]
    temp = strlower(temp)
    tinsert(db.errorFilterList, temp)
end

local buffFilterPlayerShort = {
    -- Short buffs on me
    45529,--Blood Tap
    48707,--Anti-Magic Shell
    49501,--Blade Barrier
    49039,--Lichborne
    49530,--Sudden Doom
    49016,--Unholy Frenzy
    55233,--Vampiric Blood
    51128,--Killing Machine
    49028,--Dancing Rune Weapon
    53386,--Cinderglacier
    2825,--Bloodlust
    32182,--Heroism
    26297,--Berserking
    59052,--Freezing Fog
    16870,--Clearcasting
    1850,--Dash
    22812,--Barkskin
    61346,--Nature's Grace
    
    60258,--Rune of Repulsion
    67728,--Hardening Armor
    67742,--Hardening Armor
    64763,--Heart of Iron
    67753,--Fortitude
    67699,--Fortitude
    
    62807,--Starlight
    64320,--Rune of Power
    63711,--Storm Power
    65134,--Storm Power
    
}
for i=1,#buffFilterPlayerShort do
    if tonumber(buffFilterPlayerShort[i]) then
        temp = GetSpellInfo(buffFilterPlayerShort[i])
    else
        temp = buffFilterPlayerShort[i]
    end
    temp = strlower(temp)
    tinsert(db.buffFilterPlayerShort, temp)
end

local buffFilterPlayerLong = {
    -- Long buffs on and from me
    49222,--Bone Shield
    7302,--Frost Armor
    
}
for i=1,#buffFilterPlayerLong do
    if tonumber(buffFilterPlayerLong[i]) then
        temp = GetSpellInfo(buffFilterPlayerLong[i])
    else
        temp = buffFilterPlayerLong[i]
    end
    temp = strlower(temp)
    tinsert(db.buffFilterPlayerLong, temp)
end

local buffFilterPlayerRaidBuffs = {
    -- Raid buffs
    53760,--Flask of Endless Rage
    53758,--Flask of Stoneblood
    53755,--Flask of Frost Wyrm
    54212,--Flask of Pure Mojo
    L["Well Fed"],--Well Fed
    53748,--Mighty Strength
    
    
--~     61316,--Dalaran Brilliance
--~     42995,--Arcane Intellect
--~     43002,--Arcane Brilliance
--~     132,--Detect Invisibility
--~     48469,--Mark of the Wild
--~     48470,--Gift of the Wild
--~     48934,--Greater Blessing of Might
--~     48932,--Blessing of Might
--~     25898,--Greater Blessing of Kings
--~     20217,--Blessing of Kings
--~     25899,--Greater Blessing of Sanctuary
--~     25899,--Blessing of Sanctuary
--~     48938,--Greater Blessing of Wisdom
--~     48936,--Blessing of Wisdom
--~     48074,--Prayer of Spirit
--~     48162,--Prayer of Fortitude
--~     48161,--Power Word: Fortitude
--~     53307,--Thorns
--~     
--~     53760,--Flask of Endless Rage
--~     53758,--Flask of Stoneblood
--~     53755,--Flask of Frost Wyrm
--~     54212,--Flask of Pure Mojo
--~     L["Well Fed"],--Well Fed
--~     53748,--Mighty Strength
}
for i=1,#buffFilterPlayerRaidBuffs do
    if tonumber(buffFilterPlayerRaidBuffs[i]) then
        temp = GetSpellInfo(buffFilterPlayerRaidBuffs[i])
    else
        temp = buffFilterPlayerRaidBuffs[i]
    end
    temp = strlower(temp)
    tinsert(db.buffFilterPlayerRaidBuffs, temp)
end

local buffFilterPlayerDebuffs = {
    -- Don't show these debuffs, they're annoying
    55817,--Eck Residue
    57724,--Sated
    58105,--Power of Shadron
    61251,--Power of Vesperon
    61248,--Power of Tenebron
    26013,--Deserter
    47002,--Noxious Fumes
    42514,--Squash Soul
    62692,--Aura of Despair
    64236,--Static Charged
    64227,--Static Charged
    69127,--Chill of the Throne
    70084,--Frost Aura
}
for i=1,#buffFilterPlayerDebuffs do
    if tonumber(buffFilterPlayerDebuffs[i]) then
        temp = GetSpellInfo(buffFilterPlayerDebuffs[i])
    else
        temp = buffFilterPlayerDebuffs[i]
    end
    temp = strlower(temp)
    tinsert(db.buffFilterPlayerDebuffs, temp)
end

local buffFilterTargetMyDebuffs ={
    -- Debuffs on target I care about, casted by me
    77606,--Dark Simulacrum
    50041,--Chilblains
    55667,--Desecration
    81130,--Scarlet Fever
    49194,--Unholy Blight
    
    68605,--Blue Pyrite
    56092,--Engulf in Flames
    61621,--Engulf in Flames
    
}
for i=1,#buffFilterTargetMyDebuffs do
    if tonumber(buffFilterTargetMyDebuffs[i]) then
        temp = GetSpellInfo(buffFilterTargetMyDebuffs[i])
    else
        temp = buffFilterTargetMyDebuffs[i]
    end
    temp = strlower(temp)
    tinsert(db.buffFilterTargetMyDebuffs, temp)
end

local buffFilterTargetMyBuffs ={
    
}
for i=1,#buffFilterTargetMyBuffs do
    if tonumber(buffFilterTargetMyBuffs[i]) then
        temp = GetSpellInfo(buffFilterTargetMyBuffs[i])
    else
        temp = buffFilterTargetMyBuffs[i]
    end
    temp = strlower(temp)
    tinsert(db.buffFilterTargetMyBuffs, temp)
end

local buffFilterTargetOthersBuffs ={
    -- Buffs on target I care about, not casted by me
    64465,--Shadow Beacon
    58549,--Tenacity
    69558,--Unstable Ooze
    642,--Divine Shield
    1022,--Hand of Protection
    70768,--Shroud of the Occult
    70842,--Mana Barrier
    71730,--Lay Waste
    
}
for i=1,#buffFilterTargetOthersBuffs do
    if tonumber(buffFilterTargetOthersBuffs[i]) then
        temp = GetSpellInfo(buffFilterTargetOthersBuffs[i])
    else
        temp = buffFilterTargetOthersBuffs[i]
    end
    temp = strlower(temp)
    tinsert(db.buffFilterTargetOthersBuffs, temp)
end

local buffFilterPet ={
    L["Well Fed"],--Well Fed
    
--~     48469,--Mark of the Wild
--~     48470,--Gift of the Wild
--~     48934,--Greater Blessing of Might
--~     48932,--Blessing of Might
--~     25898,--Greater Blessing of Kings
--~     20217,--Blessing of Kings
--~     25899,--Greater Blessing of Sanctuary
--~     25899,--Blessing of Sanctuary
--~     48938,--Greater Blessing of Wisdom
--~     48936,--Blessing of Wisdom
--~     48162,--Prayer of Fortitude
--~     48161,--Power Word: Fortitude
}
for i=1,#buffFilterPet do
    if tonumber(buffFilterPet[i]) then
        temp = GetSpellInfo(buffFilterPet[i])
    else
        temp = buffFilterPet[i]
    end
    temp = strlower(temp)
    tinsert(db.buffFilterPet, temp)
end
