--[[
	Copyright (c) 2009, dr_AllCOM3
    All rights reserved.

    You're allowed to use this addon, free of monetary charge,
    but you are not allowed to modify, alter, or redistribute
    this addon without express, written permission of the author.
]]

local L = LibStub("AceLocale-3.0"):GetLocale("DocsUI")
local LSM = LibStub("LibSharedMedia-3.0")
local db = {}
local temp, temp2

local fontb = [[Interface\Addons\DocsUI\media\fontb.ttf]]
local font = [[Interface\Addons\DocsUI\media\font.ttf]]
local fonti = [[Interface\Addons\DocsUI\media\fonti.ttf]]

local pvpFontSize = 20
local ZoneFontSize = 100
local SubZoneFontSize = 30      

ZoneFadeInDuration = 0.5
ZoneHoldDuration = 1.0
ZoneFadeOutDuration = 2.0
ZonePVPType = nil

function SetZoneText(showZone)
    local pvpType, isSubZonePvP, factionName = GetZonePVPInfo()
    PVPArenaTextString:SetText("")
    PVPInfoTextString:SetText("")
    local pvpTextString = PVPInfoTextString
    if isSubZonePvP then
        pvpTextString = PVPArenaTextString
    end			

    if ( pvpType == "sanctuary" ) then
        pvpTextString:SetFont(fonti, pvpFontSize, 'OUTLINE')					
        ZoneTextString:SetFont(fontb, ZoneFontSize, 'OUTLINE')
        SubZoneTextString:SetFont(font, SubZoneFontSize, 'OUTLINE') 	
        
    elseif ( pvpType == "arena" ) then
        pvpTextString:SetFont(fonti, pvpFontSize, 'OUTLINE')					
        ZoneTextString:SetFont(fontb, ZoneFontSize, 'OUTLINE')
        SubZoneTextString:SetFont(font, SubZoneFontSize, 'OUTLINE') 	
        
    elseif ( pvpType == "friendly" ) then
        pvpTextString:SetFont(fonti, pvpFontSize, 'OUTLINE')					
        ZoneTextString:SetFont(fontb, ZoneFontSize, 'OUTLINE')
        SubZoneTextString:SetFont(font, SubZoneFontSize, 'OUTLINE') 	
        
    elseif ( pvpType == "hostile" ) then
        pvpTextString:SetFont(fonti, pvpFontSize, 'OUTLINE')					
        ZoneTextString:SetFont(fontb, ZoneFontSize, 'OUTLINE')
        SubZoneTextString:SetFont(font, SubZoneFontSize, 'OUTLINE') 	
        
    elseif ( pvpType == "contested" ) then
        pvpTextString:SetFont(fonti, pvpFontSize, 'OUTLINE')					
        ZoneTextString:SetFont(fontb, ZoneFontSize, 'OUTLINE')
        SubZoneTextString:SetFont(font, SubZoneFontSize, 'OUTLINE') 	
        
    else
        ZoneTextString:SetTextColor(1.0, 0.9294, 0.7607)
        SubZoneTextString:SetTextColor(1.0, 0.9294, 0.7607)
    end

    if ZonePVPType~=pvpType then
        ZonePVPType = pvpType
    elseif not showZone then
        PVPInfoTextString:SetText("")
        SubZoneTextString:SetPoint("TOP", "ZoneTextString", "BOTTOM", 0, 0)
    end

    if PVPInfoTextString:GetText()=="" then
        SubZoneTextString:SetPoint("TOP", "ZoneTextString", "BOTTOM", 0, 0)
    else
        SubZoneTextString:SetPoint("TOP", "PVPInfoTextString", "BOTTOM", 0, 0)
    end
end



--[[ Create fonts ]]
function DocsUI:SpawnFonts()
    db = DocsUI.db.profile
    
end

DocsUIFont = CreateFrame("Frame", "DocsUIFont")

function DocsUIFont:ApplySystemFonts()
    DAMAGE_TEXT_FONT = font
    COMBAT_TEXT_HEIGHT = 24
	COMBAT_TEXT_CRIT_MAXHEIGHT = 24 + 2
	COMBAT_TEXT_CRIT_MINHEIGHT = 24 - 2
    local name, height, flags = CombatTextFont:GetFont()
    CombatTextFont:SetFont(font, 24, flags)
    
    UNIT_NAME_FONT = font
end

DocsUIFont:SetScript("OnEvent",
        function() 
           if (event == "ADDON_LOADED") then
          DocsUIFont:ApplySystemFonts()
           end
        end)
DocsUIFont:RegisterEvent("ADDON_LOADED")

DocsUIFont:ApplySystemFonts()

