﻿--[[
	Copyright (c) 2009, dr_AllCOM3
    All rights reserved.

    You're allowed to use this addon, free of monetary charge,
    but you are not allowed to modify, alter, or redistribute
    this addon without express, written permission of the author.
]]

local L = LibStub("AceLocale-3.0"):GetLocale("DocsUI")
local LSM = LibStub("LibSharedMedia-3.0")
local db
local temp, temp2 = nil

local mask="Interface\\AddOns\\DocsUI\\media\\squaremask"
local coords

--[[ Round a number ]]
-- number, decimal places
local function round(num, idp)
	local mult = 10^(idp or 0)
	return math.floor(num * mult + 0.5) / mult
end

--[[ http://www.wowwiki.com/GetMinimapShape ]]
function GetMinimapShape() return "SQUARE" end

-- onUpdate
local updateSpeed2 = 2
local lastUpdate = 0
local lastUpdate2 = 0
local function onUpdate(self, elapsed)
	lastUpdate = lastUpdate + elapsed
    lastUpdate2 = lastUpdate2 + elapsed
	
	if lastUpdate > db.updateSpeedMinimap then
		lastUpdate = 0
		
        local x, y = GetPlayerMapPosition("player")
        if(x ~= 0 and y ~= 0) then
            coords.text:SetText(round(x*100,1) ..", "..round(y*100,1))
        else
            coords.text:SetText()
        end
	end
    
    if lastUpdate2 > updateSpeed2 then
        lastUpdate2 = 0
        
        DocsUI:UpdateAttempts()
    end
end

local function onMouseWheel(self, dir)
    if dir>0 then
        MinimapZoomIn:Click()
    else
        MinimapZoomOut:Click()
    end
end

--[[ Update attempts ]]
function DocsUI:UpdateAttempts()
    if UnitAffectingCombat("player") then return end
    
    local _, instanceType = IsInInstance()
    
    if (WORLD_PVP_OBJECTIVES_DISPLAY=="2" and IsSubZonePVPPOI()) or instanceType~="raid" then return end
    
    local _, state, text = GetWorldStateUIInfo(2)
    if state~=1 or not text or not type(text)=="string" then
        Minimap.attempts:SetText(nil)
        return
    end
    
    text = { strsplit(" ", text) }
    temp = {}
    
    for i,v in ipairs(text) do
        if v and tonumber(v) then tinsert(temp, v) end
    end
    
    Minimap.attempts:SetText(tostring(temp[1]).."/"..tostring(temp[2]))
    if AlwaysUpFrame1 then
        --AlwaysUpFrame1:Hide()
        AlwaysUpFrame1Text:SetText(nil)
    end
end

--[[ Spawn Minimap ]]
function DocsUI:SpawnMinimap()
    db = DocsUI.db.profile
    
    -- Coords
    coords = CreateFrame("Button", nil, Minimap)
    coords:SetPoint("BOTTOM", Minimap, "BOTTOM", 0, db.spacingFixed)
    coords:SetWidth(100)
    coords:SetHeight(db.fontsize)
    coords:RegisterForClicks("AnyUp")

    coords.text = coords:CreateFontString(nil, "OVERLAY", "GameFontNormal")
    coords.text:SetAllPoints(coords)
    coords.text:SetFont(LSM:Fetch("font", db.font), db.fontsize)
    coords.text:SetShadowColor(0,0,0,1)
    coords.text:SetShadowOffset(1,-1)
    coords.text:SetJustifyH("CENTER")
    coords.text:SetJustifyV("CENTER")
    coords.text:SetTextColor(db.fontColor.r,db.fontColor.g,db.fontColor.b,db.fontColor.a)
    
    -- InstanceDifficulty
    MiniMapInstanceDifficulty:ClearAllPoints()
    MiniMapInstanceDifficulty:SetPoint("TOPLEFT", Minimap, "TOPLEFT", 0, 0)
    
    local attempts = MiniMapInstanceDifficulty:CreateFontString(nil, nil, "GameFontNormal")
    --attempts:SetWidth(db.width)
    attempts:SetHeight(db.height)
    attempts:SetPoint("TOP", MiniMapInstanceDifficulty, "BOTTOM")
    attempts:SetFont(LSM:Fetch("font", db.font), db.fontsize-3)
    attempts:SetJustifyH("LEFT")
    attempts:SetJustifyV("CENTER")
    attempts:SetShadowColor(0,0,0,1)
    attempts:SetShadowOffset(1,-1)
    --attempts:SetTextColor(db.fontColor.r,db.fontColor.g,db.fontColor.b,db.fontColor.a)
    Minimap.attempts = attempts
    
    -- Stuff
    MiniMapTrackingBackground:Hide()
	MiniMapTrackingButton:SetHighlightTexture("")
	MiniMapTrackingButtonBorder:SetTexture("")
	MiniMapTrackingIcon:SetTexCoord(0.065, 0.935, 0.065, 0.935)
	MiniMapTrackingIconOverlay:SetTexture("")
	MiniMapTracking:SetParent(Minimap)
	MiniMapTracking:ClearAllPoints()
	MiniMapTracking:SetPoint("BOTTOMRIGHT", 0, 0)
    
    BattlegroundShine:Hide()
	MiniMapBattlefieldBorder:SetTexture("")
	MiniMapBattlefieldFrame:SetParent(Minimap)
	MiniMapBattlefieldFrame:ClearAllPoints()
	MiniMapBattlefieldFrame:SetPoint("BOTTOMLEFT", 0, 0)
    
    MiniMapLFGFrameBorder:SetTexture("")
	MiniMapLFGFrame:SetParent(Minimap)
	MiniMapLFGFrame:ClearAllPoints()
	MiniMapLFGFrame:SetPoint("TOPLEFT", 25, 0)
    
    MiniMapMailBorder:SetTexture("")
	MiniMapMailFrame:SetParent(Minimap)
	MiniMapMailFrame:ClearAllPoints()
	MiniMapMailFrame:SetPoint("TOP", 0, 0)
	
    GameTimeFrame:SetScale(0.66)
    GameTimeFrame:SetPoint("TOPRIGHT", 0, 0)
    temp = GameTimeFrame:GetFontString()
    temp:SetAlpha(0)
    
    LoadAddOn("Blizzard_TimeManager")
    TimeManagerClockButton:ClearAllPoints()
    TimeManagerClockButton:SetPoint("TOP", Minimap, "BOTTOM", 0, 5)

    TimeManagerClockTicker:ClearAllPoints()
    TimeManagerClockTicker:SetPoint("CENTER", TimeManagerClockButton)
    
    if StreamingIcon then
        StreamingIcon:ClearAllPoints()
        StreamingIcon:SetPoint( "BOTTOMRIGHT", Minimap, "TOPLEFT", 0, 0 )
    end
    
    -- Minimap
    Minimap:SetPoint("TOPRIGHT", UIParent, -db.edgeDistance, -db.edgeDistance)
    Minimap:EnableMouseWheel()
	Minimap:SetScript("OnMouseWheel", onMouseWheel)
    Minimap:SetMaskTexture(mask)
    MinimapBorder:SetTexture(nil)
    
	MinimapBorderTop:Hide()
	MinimapZoneTextButton:Hide()
    MinimapZoomIn:Hide()
    MinimapZoomOut:Hide()
    MiniMapVoiceChatFrame:Hide()
	MiniMapVoiceChatFrame.Show = MiniMapVoiceChatFrame.Hide
    MiniMapWorldMapButton:Hide()
    MinimapNorthTag:SetAlpha(0)
    
    DocsUI:setBorder(Minimap,1)
    
    coords:SetScript("OnUpdate", onUpdate)
    
    --[[
    temp = {}
    for i,v in pairs(_G) do
        if strfind(i,"LibDBIcon") then
            tinsert(temp, v)
        end
    end
    for i=1,#temp do
        if i==1 then
            temp[i]:SetPoint("BOTTOMRIGHT", Minimap, "TOPRIGHT", db.spacingFixed, db.spacingFixed)
        else
            temp[i]:SetPoint("BOTTOMRIGHT", temp[i-1], "BOTTOMLEFT", 0, 0)
        end
    end
    ]]
    
    --[[ Align Stuff ]]
    WatchFrame:ClearAllPoints()
    WatchFrame:SetPoint("TOPRIGHT", Minimap, "BOTTOMRIGHT", 0, -db.edgeDistance)
    WatchFrame:SetHeight(600)
    WatchFrame:SetScale(0.8)
    WatchFrame.ClearAllPoints = function() end
    WatchFrame.SetPoint = function() end
    WatchFrame.SetAllPoints = function() end
end