﻿--[[
	Copyright (c) 2009, dr_AllCOM3
    All rights reserved.

    You're allowed to use this addon, free of monetary charge,
    but you are not allowed to modify, alter, or redistribute
    this addon without express, written permission of the author.
]]

--[[
ä	\195\164	Jäger = J\195\164ger
Ä	\195\132	Ärger = \195\132rger
ö	\195\182	schön = sch\195\182n
Ö	\195\150	Ödipus = \195\150dipus
ü	\195\188	Rüstung = R\195\188stung
Ü	\195\156	Übung = \195\156bung
ß	\195\159	Straße = Stra\195\159e 
]]

local L = LibStub("AceLocale-3.0"):GetLocale("DocsUI")
local LSM = LibStub("LibSharedMedia-3.0")
local db
local temp, temp2 = nil

-- Spawn the settings
function DocsUI:SpawnSettings()
    db = DocsUI.db.profile
end

--[[ Create the border ]]
local topTexture = "Interface\\Addons\\DocsUI\\media\\border\\top"
local bottomTexture = "Interface\\Addons\\DocsUI\\media\\border\\bottom"
local leftTexture = "Interface\\Addons\\DocsUI\\media\\border\\left"
local rightTexture = "Interface\\Addons\\DocsUI\\media\\border\\right"
local topleftTexture = "Interface\\Addons\\DocsUI\\media\\border\\topleft"
local toprightTexture = "Interface\\Addons\\DocsUI\\media\\border\\topright"
local bottomleftTexture = "Interface\\Addons\\DocsUI\\media\\border\\bottomleft"
local bottomrightTexture = "Interface\\Addons\\DocsUI\\media\\border\\bottomright"
function DocsUI:setBorder(self, backgroundAlpha, borderAlpha)
    db = DocsUI.db.profile
    if not backgroundAlpha then backgroundAlpha = 0 end
    local alpha = borderAlpha or 1
    
    local strata = "BACKGROUND"--"BACKGROUND"
    
    
    self:SetBackdrop(nil)
    
    local bgTexture = self:CreateTexture(nil, strata)
    bgTexture:SetTexture(db.bg)
    bgTexture:SetPoint("TOPLEFT", self, "TOPLEFT", db.inset, -db.inset)
    bgTexture:SetPoint("BOTTOMRIGHT", self, "BOTTOMRIGHT", -db.inset, db.inset)
    bgTexture:SetVertexColor(db.bgColor.r, db.bgColor.g, db.bgColor.b, backgroundAlpha)
    
    local topLeft = self:CreateTexture(nil, strata)
    topLeft:SetTexture(topleftTexture)
    topLeft:SetPoint("BOTTOMRIGHT", self, "TOPLEFT", db.borderTex, -db.borderTex)
    topLeft:SetWidth(64)
    topLeft:SetHeight(64)
    topLeft:SetVertexColor(db.borderColor.r, db.borderColor.g, db.borderColor.b, alpha)
    
    local topRight = self:CreateTexture(nil, strata)
    topRight:SetTexture(toprightTexture)
    topRight:SetPoint("BOTTOMLEFT", self, "TOPRIGHT", -db.borderTex, -db.borderTex)
    topRight:SetWidth(64)
    topRight:SetHeight(64)
    topRight:SetVertexColor(db.borderColor.r, db.borderColor.g, db.borderColor.b, alpha)
    
    local bottomLeft = self:CreateTexture(nil, strata)
    bottomLeft:SetTexture(bottomleftTexture)
    bottomLeft:SetPoint("TOPRIGHT", self, "BOTTOMLEFT", db.borderTex, db.borderTex)
    bottomLeft:SetWidth(64)
    bottomLeft:SetHeight(64)
    bottomLeft:SetVertexColor(db.borderColor.r, db.borderColor.g, db.borderColor.b, alpha)
    
    local bottomRight = self:CreateTexture(nil, strata)
    bottomRight:SetTexture(bottomrightTexture)
    bottomRight:SetPoint("TOPLEFT", self, "BOTTOMRIGHT", -db.borderTex, db.borderTex)
    bottomRight:SetWidth(64)
    bottomRight:SetHeight(64)
    bottomRight:SetVertexColor(db.borderColor.r, db.borderColor.g, db.borderColor.b, alpha)
    
    local topEdge = self:CreateTexture(nil, strata)
    topEdge:SetTexture(topTexture)
    topEdge:SetPoint("TOPLEFT", topLeft, "TOPRIGHT")
    topEdge:SetPoint("TOPRIGHT", topRight, "TOPLEFT")
    topEdge:SetHeight(64)
    topEdge:SetVertexColor(db.borderColor.r, db.borderColor.g, db.borderColor.b, alpha)
    
    local bottomEdge = self:CreateTexture(nil, strata)
    bottomEdge:SetTexture(bottomTexture)
    bottomEdge:SetPoint("BOTTOMLEFT", bottomLeft, "BOTTOMRIGHT")
    bottomEdge:SetPoint("BOTTOMRIGHT", bottomRight, "BOTTOMLEFT")
    bottomEdge:SetHeight(64)
    bottomEdge:SetVertexColor(db.borderColor.r, db.borderColor.g, db.borderColor.b, alpha)
    
    local leftEdge = self:CreateTexture(nil, strata)
    leftEdge:SetTexture(leftTexture)
    leftEdge:SetPoint("TOPLEFT", topLeft, "BOTTOMLEFT")
    leftEdge:SetPoint("BOTTOMLEFT", bottomLeft, "TOPLEFT")
    leftEdge:SetWidth(64)
    leftEdge:SetVertexColor(db.borderColor.r, db.borderColor.g, db.borderColor.b, alpha)
    
    local rightEdge = self:CreateTexture(nil, strata)
    rightEdge:SetTexture(rightTexture)
    rightEdge:SetPoint("TOPRIGHT", topRight, "BOTTOMRIGHT")
    rightEdge:SetPoint("BOTTOMRIGHT", bottomRight, "TOPRIGHT")
    rightEdge:SetWidth(64)
    rightEdge:SetVertexColor(db.borderColor.r, db.borderColor.g, db.borderColor.b, alpha)
end

function DocsUI:setBorderLight(self, backgroundAlpha, borderAlpha)
    db = DocsUI.db.profile
    if not backgroundAlpha then backgroundAlpha = 0 end
    local alpha = borderAlpha or 1
    
    local strata = "BACKGROUND"--"BACKGROUND"
    
    
    self:SetBackdrop(nil)
    
    local bgTexture = self:CreateTexture(nil, strata)
    bgTexture:SetTexture(db.bg)
    bgTexture:SetPoint("TOPLEFT", self, "TOPLEFT", db.inset, -db.inset)
    bgTexture:SetPoint("BOTTOMRIGHT", self, "BOTTOMRIGHT", -db.inset, db.inset)
    bgTexture:SetVertexColor(db.bgColor.r, db.bgColor.g, db.bgColor.b, backgroundAlpha)
    
    
end

--[[ Create the threat glow ]]
local glowTexture = "Interface\\Addons\\DocsUI\\media\\statusbarGlow"
function DocsUI:setGlow(self)
    local strata = "BORDER"
    local alpha = 1
    local r = 1
    local g = 1
    local b = 1
    
    local glow = self:CreateTexture(nil, strata)
    glow:SetTexture(glowTexture)
    glow:SetPoint("CENTER", self, "CENTER", 0, 0)
    glow:SetWidth(self:GetWidth()+10)
    glow:SetHeight(self:GetHeight()+10)
    glow:SetVertexColor(r,g,b,alpha)
    
    return glow
end

--[[ Create icon border ]]
local iconBorderTexture = "Interface\\AddOns\\rActionButtonStyler\\media\\gloss"
function DocsUI:setIconBorder(self, icon)
    local h = icon:GetWidth()
    local w = icon:GetHeight()
    
    local borderframe = CreateFrame("Frame", nil, buff)
    borderframe:SetWidth(h)
    borderframe:SetHeight(w)
    borderframe:SetPoint("LEFT", buff, db.spacingFixed, 0)
    local border = borderframe:CreateTexture(nil, "OVERLAY")
    border:SetTexture("Interface\\AddOns\\rActionButtonStyler\\media\\gloss")
    border:SetVertexColor(db.bgColor.r, db.bgColor.g, db.bgColor.b, 1)
    border:SetPoint("TOPLEFT", borderframe, "TOPLEFT", -2, 2)
    border:SetPoint("BOTTOMRIGHT", borderframe, "BOTTOMRIGHT", 2, -2)
    
    icon:SetTexCoord(0.1,0.9,0.1,0.9)
    
    return borderframe
end

DocsUI.raidIconList = {
    L["Yellow Star"],
    L["Orange Circle"],
    L["Purple Diamond"],
    L["Green Triangle"],
    L["White Moon"],
    L["Blue Square"],
    L["Red X"],
    L["White Skull"],
    }
