--[[
	Copyright (c) 2009, dr_AllCOM3
    All rights reserved.

    You're allowed to use this addon, free of monetary charge,
    but you are not allowed to modify, alter, or redistribute
    this addon without express, written permission of the author.
]]

DocsUI_Tooltip = LibStub("AceAddon-3.0"):NewAddon("DocsUI_Tooltip", "AceEvent-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("DocsUI")
local LSM = LibStub("LibSharedMedia-3.0")
local settingsUser
local temp,temp2 = nil

--[[ Print ]]
local function p( text )
	ChatFrame3:AddMessage( tostring( text ) )
end

local playerName = UnitName("player")
local anchorMouse = false

--[[ Set font & stuff ]]
local function spawnTooltip()
    GameTooltip.raidIcon = GameTooltipStatusBar:CreateTexture(nil, "OVERLAY")
    GameTooltip.raidIcon:SetWidth(32)
    GameTooltip.raidIcon:SetHeight(32)
    GameTooltip.raidIcon:SetPoint("CENTER", GameTooltipStatusBar)

    DocsUI:setBorder(GameTooltip, settingsUser.tooltipBgAlpha)
    DocsUI:setBorder(ItemRefTooltip, settingsUser.tooltipBgAlpha)
    DocsUI:setBorder(ShoppingTooltip1, settingsUser.tooltipBgAlpha)
    DocsUI:setBorder(ShoppingTooltip2, settingsUser.tooltipBgAlpha)
    DocsUI:setBorder(ShoppingTooltip3, settingsUser.tooltipBgAlpha)
    DocsUI:setBorder(DropDownList1MenuBackdrop, settingsUser.tooltipBgAlpha)
    DocsUI:setBorder(DropDownList2MenuBackdrop, settingsUser.tooltipBgAlpha)
    
    GameTooltip:ClearLines()
    for i=1,30,1 do
        GameTooltip:AddLine("-")
    end
    for i=1,30,1 do
        temp = getglobal("GameTooltipTextLeft" .. i)
        temp2 = getglobal("GameTooltipTextRight" .. i)
        temp:SetTextColor(settingsUser.fontColor.r,settingsUser.fontColor.g,settingsUser.fontColor.b,settingsUser.fontColor.a)
        if i==1 then
            temp:SetFont(LSM:Fetch("font", settingsUser.fontb),settingsUser.fontsize-2+2)
        else
            temp:SetFont(LSM:Fetch("font", settingsUser.font),settingsUser.fontsize-2)
        end
        temp2:SetFont(LSM:Fetch("font", settingsUser.font),settingsUser.fontsize-2)
        temp:SetShadowColor(0,0,0,1)
        temp:SetShadowOffset(1,-1)
        temp2:SetShadowColor(0,0,0,1)
        temp2:SetShadowOffset(1,-1)
    end
    
    --[[ Item Levels ]]
    local function AddItemlevel(self)
        local _, link = self:GetItem()
        local level = link and select(4, GetItemInfo(link))
        if(level and level>0) then
            self:AddLine(L["Item Level"]..": "..level, ilvlR, ilvlG, ilvlB)
        end
    end

    GameTooltip:HookScript("OnTooltipSetItem", AddItemlevel)
    ItemRefTooltip:HookScript("OnTooltipSetItem", AddItemlevel)
end

--[[ Health Bar ]]
old_HealthBar_OnValueChanged = HealthBar_OnValueChanged
function HealthBar_OnValueChanged(self, value, smooth)
	if not value then
		return
	end
    
	local unit = select(2, GameTooltip:GetUnit())
    
    if not unit or UnitName(unit)==UNKNOWN then
        return
    elseif UnitIsPlayer(unit) then
        local unitClassColor = RAID_CLASS_COLORS[select(2,UnitClass(unit))] or { r = 1, g = 0, b = 1 }
        GameTooltipStatusBar:SetStatusBarColor(unitClassColor.r, unitClassColor.g, unitClassColor.b,settingsUser.bgColor.a+(1-settingsUser.bgColor.a)/2)
    else
        if (UnitIsTapped(unit) and not UnitIsTappedByPlayer(unit)) or UnitIsDead(unit) then
            GameTooltipStatusBar:SetStatusBarColor(0.5, 0.5, 0.5,settingsUser.bgColor.a+(1-settingsUser.bgColor.a)/2)
        else
            local unitReactionColor = { r = select(1, UnitSelectionColor(unit)), g = select(2, UnitSelectionColor(unit)), b = select(3, UnitSelectionColor(unit)) }
            GameTooltipStatusBar:SetStatusBarColor(unitReactionColor.r, unitReactionColor.g, unitReactionColor.b,settingsUser.bgColor.a+(1-settingsUser.bgColor.a)/2)
        end
    end		
end

--[[ Tooltip ]]
GameTooltip:HookScript("OnTooltipSetUnit", function(self)
	local unit = select(2, self:GetUnit())
    
    if settingsUser.dontShowTargetTooltip and unit and unit=="target" then
        GameTooltip:Hide()
        return
    end
    
    if unit and UnitName(unit)~=UNKNOWN then
		local unitIsPlayer = UnitIsPlayer(unit)
		local unitClassColor = RAID_CLASS_COLORS[select(2,UnitClass(unit))] or { r = 1, g = 0, b = 1 }
		local unitLevel = UnitLevel(unit)
		local unitClassification = UnitClassification(unit)
		local unitName = UnitName(unit)
		local unitReactionColor = { r = select(1, UnitSelectionColor(unit)), g = select(2, UnitSelectionColor(unit)), b = select(3, UnitSelectionColor(unit)) }
		local isInInstance = select(2, IsInInstance())
		local difficultyColor = GetQuestDifficultyColor(unitLevel)
		local unitTargetName = UnitName(unit .. "target")
		local unitTargetClassColor = RAID_CLASS_COLORS[select(2,UnitClass(unit .. "target"))] or { r = 1, g = 0, b = 1 }
		local unitTargetReactionColor = { r = select(1, UnitSelectionColor(unit .. "target")), g = select(2, UnitSelectionColor(unit .. "target")), b = select(3, UnitSelectionColor(unit .. "target")) }
		
		if UnitLevel(unit)==-1 then
			unitLevel = "|cffff0000??|r"
		end
        
        GameTooltipTextLeft1:SetText(unitName)
        
        if unitIsPlayer then
            if GetGuildInfo(unit) then
                GameTooltipTextLeft2:SetText("<"..GameTooltipTextLeft2:GetText()..">")
            end
			
            for i=2,GameTooltip:NumLines(),1 do
				if getglobal("GameTooltipTextLeft"..i):GetText():find("^" .. LEVEL) then
					getglobal("GameTooltipTextLeft"..i):SetText(format("|cff%02x%02x%02x%s|r", difficultyColor.r*255, difficultyColor.g*255, difficultyColor.b*255, unitLevel).." "..UnitRace(unit))
                    break
				end
			end
			
			GameTooltipStatusBar:SetStatusBarColor(unitClassColor.r, unitClassColor.g, unitClassColor.b,settingsUser.bgColor.a+(1-settingsUser.bgColor.a)/2)
            GameTooltipTextLeft1:SetTextColor(unitClassColor.r, unitClassColor.g, unitClassColor.b)
		else
			if unitClassification=="worldboss" then
				unitClassification = "+++"
			elseif unitClassification=="rareelite" then
				unitClassification = "+*"
			elseif unitClassification=="elite" then
				unitClassification = "+"
			elseif unitClassification=="rare" then
				unitClassification = "*"
			else
				unitClassification = " "
			end
			
			for i=2, GameTooltip:NumLines(), 1 do
				if getglobal("GameTooltipTextLeft"..i):GetText():find("^" .. LEVEL) then
                    unitLevel = unitLevel..unitClassification
					getglobal("GameTooltipTextLeft"..i):SetText(format("|cff%02x%02x%02x%s|r", difficultyColor.r*255, difficultyColor.g*255, difficultyColor.b*255, unitLevel))
					break
				end
			end
			
			if (UnitIsTapped(unit) and not UnitIsTappedByPlayer(unit)) or UnitIsDead(unit) then
				GameTooltipStatusBar:SetStatusBarColor(0.5, 0.5, 0.5,settingsUser.bgColor.a+(1-settingsUser.bgColor.a)/2)
                GameTooltipTextLeft1:SetTextColor(0.5, 0.5, 0.5)
			else
				GameTooltipStatusBar:SetStatusBarColor(unitReactionColor.r, unitReactionColor.g, unitReactionColor.b,settingsUser.bgColor.a+(1-settingsUser.bgColor.a)/2)
				GameTooltipTextLeft1:SetTextColor(unitReactionColor.r, unitReactionColor.g, unitReactionColor.b)
			end
		end		
		
		if UnitExists(unit.."target") then
			if UnitName("player")==unitTargetName then
				self:AddLine("|cffff00ff".."-> #"..L["YOU"].."#".."|r", 1, 1, 1)
            else
				if UnitIsPlayer(unit.."target") then
					self:AddLine(format("|cff%02x%02x%02x-> %s|r", unitTargetClassColor.r*255, unitTargetClassColor.g*255, unitTargetClassColor.b*255, unitTargetName), 1, 1, 1)
				else
					self:AddLine(format("|cff%02x%02x%02x-> %s|r", unitTargetReactionColor.r*255, unitTargetReactionColor.g*255, unitTargetReactionColor.b*255, unitTargetName), 1, 1, 1)
				end
            end
		end
		for i=2, GameTooltip:NumLines(), 1 do
			if not QuestHelper and getglobal("GameTooltipTextLeft"..i):GetText():find(PVP_ENABLED) then --QuestHelper modifies the tooltip..
				getglobal("GameTooltipTextLeft"..i):SetText(nil)
				break
			end
		end
		
        if unit then
            local name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable
            temp = nil
            temp2 = nil
            
            for i=1,40 do
                name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable = UnitAura(unit, i, "HARMFUL")
                
                if name and name==frostFeverLocal and unitCaster=="player" then
                    temp = expirationTime
                elseif name and name==bloodPlagueLocal and unitCaster=="player" then
                    temp2 = expirationTime
                elseif not name then
                    break
                end
            end
            
            local isTanking, status, threatpct, rawthreatpct, threatvalue = UnitDetailedThreatSituation("player", unit)
            
            if tonumber(threatpct) and not isTanking then
                --self:AddLine(format("|cff%02x%02x%02xThreat: %s|r", 1, 0.5, 0, threatpct), 1, 0.5, 0)
            end
        end
        
        local raidIndex = GetRaidTargetIndex(unit)
        if raidIndex then
            GameTooltip.raidIcon:SetTexture("Interface\\TargetingFrame\\UI-RaidTargetingIcon_"..raidIndex)
        else
            GameTooltip.raidIcon:SetTexture("")
        end
        
        GameTooltipStatusBar:SetStatusBarTexture(LSM:Fetch("statusbar", settingsUser.texture))
		GameTooltipStatusBar:SetHeight(settingsUser.heightSmall)
        GameTooltipStatusBar:SetPoint("TOPLEFT", 0, -2)
        GameTooltipStatusBar:SetPoint("TOPRIGHT", 0, -2)
    end
end)
GameTooltip:HookScript("OnTooltipSetItem", function(self)
	
end)
GameTooltip:HookScript("OnTooltipSetSpell", function(self)
	
end)

local frame = CreateFrame("Frame", "ItemRefTooltipIconFrame", ItemRefTooltip)
frame:SetWidth(37)
frame:SetHeight(37)
frame:SetBackdrop({ edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 }});
frame:SetPoint("TOPRIGHT", ItemRefTooltip, "TOPLEFT", 2, 0)
frame.icon = frame:CreateTexture(frame:GetName() .. "IconTexture", "BACKGROUND")
frame.icon:SetWidth(33)
frame.icon:SetHeight(33)
frame.icon:SetPoint("CENTER", frame, "CENTER", 0, 0)
frame.icon:SetTexCoord(0.07, 0.93, 0.07, 0.93)
frame.count = frame:CreateFontString(frame:GetName() .. "Count", "ARTWORK", "NumberFontNormal")
frame.count:SetJustifyH("RIGHT")
frame.count:SetPoint("BOTTOMRIGHT", frame.icon, -2, 2)

hooksecurefunc("SetItemRef", function(link, text, button)
	if ( ItemRefTooltipIconFrame:IsShown() ) then
		SetItemButtonCount(ItemRefTooltipIconFrame, 0)
		ItemRefTooltipIconFrame:Hide()
	end
	if ( strsub(link, 1, 4) == "item" ) then
		local itemStackCount, _, itemTexture = select(8, GetItemInfo(strmatch(link, "item:(%d+)")))
		itemStackCount = itemStackCount or 0
		SetItemButtonTexture(ItemRefTooltipIconFrame, itemTexture)
		SetItemButtonCount(ItemRefTooltipIconFrame, itemStackCount)
		ItemRefTooltipIconFrame:Show()
	elseif ( strsub(link, 1, 5) == "spell" ) then
		SetItemButtonTexture(ItemRefTooltipIconFrame, select(3, GetSpellInfo(strmatch(link, "spell:(%d+)"))))
		ItemRefTooltipIconFrame:Show()
	elseif ( strsub(link, 1, 11) == "achievement") then
		SetItemButtonTexture(ItemRefTooltipIconFrame, select(10, GetAchievementInfo(strmatch(link, "achievement:(%d+)"))))
		ItemRefTooltipIconFrame:Show()
	end
end)

--[[ Anchor ]]
function GameTooltip_SetDefaultAnchor(tooltip, parent)
    if settingsUser.tooltipAnchor==L["Mouse"] then
        tooltip:SetOwner(parent, "ANCHOR_CURSOR")
    elseif settingsUser.tooltipAnchor==L["Right"] then
        if DocsUI.oUFtargettarget then
            tooltip:SetOwner( parent, "ANCHOR_NONE" )
            tooltip:SetPoint( "TOPLEFT", DocsUI.oUFtargettarget, "TOPRIGHT", settingsUser.spacing*4*4, 0 )
        else
            
        end
    end
end

-- OnInitialize.
function DocsUI_Tooltip:OnInitialize()
    
end
-- OnEnable.
function DocsUI_Tooltip:OnEnable()
    settingsUser = DocsUI.db.profile
    
    spawnTooltip()
    
    GameTooltip:HookScript("OnShow", function(self)
        if GetMouseFocus()==WorldFrame and not UnitExists("mouseover") then
			self.doodad = true
		end
    end)
    
    GameTooltip:HookScript("OnHide", function(self)
        self.doodad = false
    end)
    
    GameTooltip:HookScript("OnUpdate", function(self)
        if GetMouseFocus()==WorldFrame and not UnitExists("mouseover") and not self.doodad then
            GameTooltip:Hide()
            return
        end
    end)
end
function DocsUI_Tooltip:OnDisable()
	
end